package com.mxnavi.tspv2.catering.model;

import java.util.List;

/**
 * Created by Administrator on 2018/5/23.
 */

public class GetDetailResult {

    // 大图列表，尺寸为800×800
    List<String> photoUrls;

    // 店铺详细信息跳转链接
    String businessUrl;

    // 所在区域信息列表，如[徐汇区,徐家汇]
    List<String> regions;

    // 口味评分，十分制
    float taste;

    // 店铺名
    String name;

    // 店铺ID
    Integer businessId;

    // 店铺经度坐标
    float longitude;

    // 小图列表，尺寸为278×200
    List<String> sPhotoUrls;

    // 星级评分，5.0代表五星，4.5代表四星半，依此类推
    Float avgRating;

    // 店铺状态，1代表正常营业，2代表暂停营业（比如停业装修、临时关门）
    Integer status;

    // 环境评分，十分制
    Float decoration;

    // 店铺地址
    String address;

    // 店铺人气
    Integer popular;

    // 服务评分，十分制
    Float service;

    // 点评总数量
    int ugcCount;

    // 所属分类信息列表，使用分类树结构，如[“美食,火锅”, “酒店,婚宴酒店”]
    List<String> categories;

    // 店铺纬度坐标
    float latitude;

    // 带区号的电话号码
    String telephone;

    // 人均价格，单位:元，若没有人均，返回-1
    Integer avgPrice;

    // 商详页二维码图片BASE64编码
    String qrCode;

    // 营业时间
    String businessHour;

    /**
     * 获取大图列表，尺寸为800×800
     * @return
     */
    public List<String> getPhotoUrls() {
        return photoUrls;
    }

    /**
     * 设置大图列表，尺寸为800×800
     * @param photoUrls
     */
    public void setPhotoUrls(List<String> photoUrls) {
        this.photoUrls = photoUrls;
    }

    /**
     * 获取店铺详细信息跳转链接
     * @return
     */
    public String getBusinessUrl() {
        return businessUrl;
    }

    /**
     * 设置店铺详细信息跳转链接
     * @param businessUrl
     */
    public void setBusinessUrl(String businessUrl) {
        this.businessUrl = businessUrl;
    }

    /**
     * 获取所在区域信息列表，如[徐汇区,徐家汇]
     * @return
     */
    public List<String> getRegions() {
        return regions;
    }

    /**
     * 设置所在区域信息列表，如[徐汇区,徐家汇]
     * @param regions
     */
    public void setRegions(List<String> regions) {
        this.regions = regions;
    }

    /**
     * 获取口味评分，十分制
     * @return
     */
    public float getTaste() {
        return taste;
    }

    /**
     * 设置口味评分，十分制
     * @param taste
     */
    public void setTaste(float taste) {
        this.taste = taste;
    }

    /**
     * 获取店铺名
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * 设置店铺名
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * 获取店铺ID
     * @return
     */
    public Integer getBusinessId() {
        return businessId;
    }

    /**
     * 设置店铺ID
     * @param businessId
     */
    public void setBusinessId(Integer businessId) {
        this.businessId = businessId;
    }

    /**
     * 获取店铺经度坐标
     * @return
     */
    public float getLongitude() {
        return longitude;
    }

    /**
     * 设置店铺经度坐标
     * @param longitude
     */
    public void setLongitude(float longitude) {
        this.longitude = longitude;
    }

    /**
     * 获取小图列表，尺寸为278×200
     * @return
     */
    public List<String> getsPhotoUrls() {
        return sPhotoUrls;
    }

    /**
     * 设置小图列表，尺寸为278×200
     * @param sPhotoUrls
     */
    public void setsPhotoUrls(List<String> sPhotoUrls) {
        this.sPhotoUrls = sPhotoUrls;
    }

    /**
     * 获取星级评分，5.0代表五星，4.5代表四星半，依此类推
     * @return
     */
    public Float getAvgRating() {
        return avgRating;
    }

    /**
     * 设置星级评分，5.0代表五星，4.5代表四星半，依此类推
     * @param avgRating
     */
    public void setAvgRating(Float avgRating) {
        this.avgRating = avgRating;
    }

    /**
     * 获取店铺状态，1代表正常营业，2代表暂停营业（比如停业装修、临时关门）
     * @return
     */
    public int getStatus() {
        return status;
    }

    /**
     * 设置店铺状态，1代表正常营业，2代表暂停营业（比如停业装修、临时关门）
     * @param status
     */
    public void setStatus(int status) {
        this.status = status;
    }

    /**
     * 获取环境评分，十分制
     * @return
     */
    public Float getDecoration() {
        return decoration;
    }

    /**
     * 设置环境评分，十分制
     * @param decoration
     */
    public void setDecoration(Float decoration) {
        this.decoration = decoration;
    }

    /**
     * 获取店铺地址
     * @return
     */
    public String getAddress() {
        return address;
    }

    /**
     * 设置店铺地址
     * @param address
     */
    public void setAddress(String address) {
        this.address = address;
    }

    /**
     * 获取店铺人气
     * @return
     */
    public Integer getPopular() {
        return popular;
    }

    /**
     * 设置店铺人气
     * @param popular
     */
    public void setPopular(Integer popular) {
        this.popular = popular;
    }

    /**
     * 获取服务评分，十分制
     * @return
     */
    public Float getService() {
        return service;
    }

    /**
     * 设置服务评分，十分制
     * @param service
     */
    public void setService(Float service) {
        this.service = service;
    }

    /**
     * 获取点评总数量
     * @return
     */
    public int getUgcCount() {
        return ugcCount;
    }

    /**
     * 设置点评总数量
     * @param ugcCount
     */
    public void setUgcCount(int ugcCount) {
        this.ugcCount = ugcCount;
    }

    /**
     * 获取所属分类信息列表，使用分类树结构，如[“美食,火锅”, “酒店,婚宴酒店”]
     * @return
     */
    public List<String> getCategories() {
        return categories;
    }

    /**
     * 设置所属分类信息列表，使用分类树结构，如[“美食,火锅”, “酒店,婚宴酒店”]
     * @param categories
     */
    public void setCategories(List<String> categories) {
        this.categories = categories;
    }

    /**
     * 获取店铺纬度坐标
     * @return
     */
    public float getLatitude() {
        return latitude;
    }

    /**
     * 设置店铺纬度坐标
     * @param latitude
     */
    public void setLatitude(float latitude) {
        this.latitude = latitude;
    }

    /**
     * 获取带区号的电话号码
     * @return
     */
    public String getTelephone() {
        return telephone;
    }

    /**
     * 设置带区号的电话号码
     * @param telephone
     */
    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    /**
     * 获取人均价格，单位:元，若没有人均，返回-1
     * @return
     */
    public Integer getAvgPrice() {
        return avgPrice;
    }

    /**
     * 设置人均价格，单位:元，若没有人均，返回-1
     * @param avgPrice
     */
    public void setAvgPrice(Integer avgPrice) {
        this.avgPrice = avgPrice;
    }

    /**
     * 获取商详页二维码图片BASE64编码
     * @return
     */
    public String getQrCode() {
        return qrCode;
    }

    /**
     * 设置商详页二维码图片BASE64编码
     * @param qrCode
     */
    public void setQrCode(String qrCode) {
        this.qrCode = qrCode;
    }

    /**
     * 获取营业时间
     * @return
     */
    public String getBusinessHour() {
        return businessHour;
    }

    /**
     * 设置营业时间
     * @param businessHour
     */
    public void setBusinessHour(String businessHour) {
        this.businessHour = businessHour;
    }

}
