package com.mxnavi.tspv2.core;

import android.util.Log;

import com.mxnavi.tspv2.core.message.MxNGTPMessage;
import com.mxnavi.tspv2.utils.Utils;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.concurrent.PriorityBlockingQueue;
import java.util.concurrent.TimeUnit;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

/**
 * Created by Administrator on 2017/11/13.
 */

public class OkHttpRequest implements RequestInterface{
    OkHttpClient client;
    protected  PriorityBlockingQueue<PrioritizedRequestMessage> cacheQueue =new PriorityBlockingQueue<PrioritizedRequestMessage>();
    protected CopyOnWriteArrayList<PrioritizedRequestMessage> processingMsgList =   new CopyOnWriteArrayList <PrioritizedRequestMessage>();
    //    public static PriorityBlockingQueue<PrioritizedRequestMessage> cacheQueue =new PriorityBlockingQueue<PrioritizedRequestMessage>();
//    protected static CopyOnWriteArrayList<PrioritizedRequestMessage> processingMsgList =   new CopyOnWriteArrayList <PrioritizedRequestMessage>();
    protected Map<Integer,Call> requestHandleMap =  new ConcurrentHashMap<Integer,Call>();
    public OkHttpRequest(){
        client = new OkHttpClient.Builder()
                .connectTimeout(10, TimeUnit.SECONDS)
                .readTimeout(20, TimeUnit.SECONDS)
                .build();

    }


    private Call sendHttpRequest(final PrioritizedRequestMessage requestMessage){
//        String url = "http://mx-t10-http-test-v1.mxnavi.com:8102/mx_dspt/requestDSPT";
        final MxNGTPMessage.MxMessage businessMessage = requestMessage.getBusinessMessage();
        RequestBody formBody =  RequestBody.create(null,businessMessage.toByteArray());

        final Request request = new Request.Builder()
                .url( Config.HTTP_URL)
                .post(formBody)
                .build();
        Call call = client.newCall(request);
        call.enqueue(new Callback() {
            @Override
            public void onFailure(Call call, IOException e) {
                Log.e("info", String.valueOf(e));
                if ("java.net.SocketTimeoutException".equals( e.toString())) {
                    // 超时
                    BaseTsp baseTsp =  BaseTsp.requestMap.get(requestMessage.evenId);
                    if(baseTsp!=null) {
                        baseTsp.sendResponseMsg(requestMessage.evenId,BaseTsp.MESSAGE_TIMEOUT,null);
                    }
                    onFinishRequest(requestMessage.evenId);
                }else{
                    ResponseDispathUtil.instance().disPathHttpResponse(requestMessage.evenId, 0);
                }


            }
            @Override
            public void onResponse(Call call, Response response) throws IOException {
                if( response.isSuccessful()){
                    Utils.loge("okhttp onSuccess");
                    try{
                        MxNGTPMessage.MxMessage mxMessage = MessageBuilder.instance().decode(response.body().bytes());
                        ResponseDispathUtil.instance().disPathResponse(mxMessage);
                    }catch (Exception e){
                        e.printStackTrace();
                        ResponseDispathUtil.instance().disPathHttpResponse(businessMessage.getNgtpMessage().getDispatcherData().getEventId(), 0);
                    }
                }else{
                    Utils.loge("okhttp respcode="+response.code());
                    ResponseDispathUtil.instance().disPathHttpResponse(requestMessage.evenId, response.code());
                }


            }
        });
        processingMsgList.add(requestMessage);
        return call;

//
//
//
//        AsyncHttpResponseHandler asyncHttpResponseHandler = new AsyncHttpResponseHandler(true){
//            @Override
//            public  void onFailure(int var1, Header[] var2, byte[] var3, Throwable var4){
//                if(var4!=null){
//                    Utils.loge("htttp-onFailure-statuscode="+var1+" Throwable="+var4.toString());
//                }else{
//                    Utils.loge("htttp-onFailure-statuscode="+var1);
//                }
//
//                if(var1==0){// 连接错误
//                    if ("java.net.SocketTimeoutException".equals(var4.toString())) {
//                        // 连接超时
//                        // 超时
//                        BaseTsp baseTsp =  BaseTsp.requestMap.get(requestMessage.evenId);
//                        if(baseTsp!=null) {
//                            baseTsp.sendResponseMsg(requestMessage.evenId,BaseTsp.MESSAGE_TIMEOUT,null);
//                        }
//                        onFinishRequest(requestMessage.evenId);
//                    }else{
//                        ResponseDispathUtil.instance().disPathHttpResponse(requestMessage.evenId, var1);
//                    }
//                }else{// 服务器错误
//                    ResponseDispathUtil.instance().disPathHttpResponse(requestMessage.evenId, var1);
//                }
//
//            }
//            @Override
//            public void onSuccess(int var1, Header[] var2, byte[] var3){
//                Utils.loge("http onSuccess");
//                try{
//                    MxNGTPMessage.MxMessage mxMessage = MessageBuilder.instance().decode(var3);
//                    ResponseDispathUtil.instance().disPathResponse(mxMessage);
//                }catch (Exception e){
//                    e.printStackTrace();
//                    ResponseDispathUtil.instance().disPathHttpResponse(businessMessage.getNgtpMessage().getDispatcherData().getEventId(), var1);
//                }
//
//            }
//            public void onCancel(){
//
//            }
//        };
//        asyncHttpResponseHandler.setUseSynchronousMode(true);
//
//        return client.post(null, Config.HTTP_URL, entity,requestMessage ,null, asyncHttpResponseHandler,onRunListener);

    }
//    OnRunListener onRunListener = new OnRunListener(){
//        public void onRunStart(PrioritizedRequestMessage prioritizedRequestMessage){
//            processingMsgList.add(prioritizedRequestMessage);
//        }
//    };

    @Override
    public void reConnection(){
        // 遍历正在执行的请求无高优先级的，则取消掉，然后再重新发请求，即重新按照优先级高低排队
        PrioritizedRequestMessage requestMessage = null;
        Iterator<PrioritizedRequestMessage> iterator = processingMsgList.iterator();
        while(iterator.hasNext()){
            requestMessage = iterator.next();
            if(requestMessage.priority!=Config.PRIORITY_HIGH){
                processingMsgList.remove(requestMessage);
                int evenId = requestMessage.evenId;
                Call call = requestHandleMap.remove(evenId);
                call.cancel();
                // 重新发请求
                sendRequest(requestMessage);
                Utils.loge("REsendRequest evenId="+evenId);
                break;
            }
        }




    }
    //    private static void submitMsg(final PrioritizedRequestMessage message){
//        processingMsgList.add(message);
//        RequestHandle requestHandle = HttpRequest.sendRequest(message.getBusinessMessage());
//        requestHandleMap.put(message.evenId, requestHandle);
//
//    }
    @Override
    public void sendRequest(PrioritizedRequestMessage requestMessage){

        Call requestHandle = sendHttpRequest(requestMessage);
        requestHandleMap.put(requestMessage.evenId, requestHandle);
    }
    @Override
    public  void submitCacheMessage(){
        Utils.loge("HTTP submitCacheMessage start");
        while (cacheQueue.size()>0) {
            PrioritizedRequestMessage msg = cacheQueue.poll();
            Utils.loge("submit cacheQueue==---"+msg.evenId);
            sendRequest(msg);
        }
    }
    @Override
    public void cancelRequest(int requestId){
        Call requestHandle = requestHandleMap.get(requestId);
        if(requestHandle!=null){
            requestHandle.cancel();
        }
        requestHandleMap.remove(requestId);
        onFinishRequest(requestId);
        // 去掉回调记录
        BaseTsp baseTsp =  BaseTsp.requestMap.get(requestId);
        if(baseTsp!=null){
            baseTsp.removeCallbackMap(requestId);
        }
    }
    /**
     * 去除请求消息记录
     * @param requestId
     */
    @Override
    public  void onFinishRequest(int requestId){
        Utils.loge("onFinishRequest.requestId=" + requestId);
        boolean s =processingMsgList.remove(new PrioritizedRequestMessage(requestId));
        requestHandleMap.remove(requestId);
        Utils.loge("processingMsgList.remove=" + s);
        Utils.loge("processingMsgList.size=" + processingMsgList.size());
        Utils.loge("requestHandleMap.size="+requestHandleMap.size());
    }
    @Override
    public  void clearStorage(){
        processingMsgList.clear();
        requestHandleMap.clear();
        BaseTsp.requestMap.clear();
    }


}
