package com.mxnavi.tspv2.core;

import com.mxnavi.tspv2.utils.Utils;

import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.concurrent.PriorityBlockingQueue;

import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelFutureListener;

/**
 * Created by Administrator on 2016/3/30.
 */
public class TcpRequest implements RequestInterface{
    //    private static Map<MxNGTPMessage.ServiceType,ResponseListener> listenerHashMap = new HashMap<MxNGTPMessage.ServiceType,ResponseListener>();

    protected  PriorityBlockingQueue<PrioritizedRequestMessage> cacheQueue =new PriorityBlockingQueue<PrioritizedRequestMessage>();
    protected  PriorityBlockingQueue<PrioritizedRequestMessage> requestQueue =new PriorityBlockingQueue<PrioritizedRequestMessage>();
    protected  CopyOnWriteArrayList<PrioritizedRequestMessage> processingMsgList =   new CopyOnWriteArrayList <PrioritizedRequestMessage>();
    //    protected static CopyOnWriteArrayList<PrioritizedRequestMessage> sendingMsgList =   new CopyOnWriteArrayList <PrioritizedRequestMessage>();
    protected  Map<Integer,ChannelFuture> channelFutureMap =  new ConcurrentHashMap<Integer,ChannelFuture>();
    //    protected static List<PrioritizedRequestMessage> failRequestList =new ArrayList<PrioritizedRequestMessage>();
//    protected static PriorityBlockingQueue<PrioritizedRequestMessage> failRequestQueue =new PriorityBlockingQueue<PrioritizedRequestMessage>();
     Thread thread ;
    //    static volatile boolean IS_STOP_SENDING_REQUEST = false;

    @Override
    public void sendRequest(PrioritizedRequestMessage requestMessage){
        Utils.loge("tcp sendRequest requestMessage.evenId="+requestMessage.evenId);
        requestQueue.offer(requestMessage);
        if(thread == null){
            thread =  new Thread(new TakeRequestTask());
            thread.setName("TSPSDK_TakeRequestTask");
            thread.start();
        }
    }
    @Override
    public  void submitCacheMessage(){
        Utils.loge("tcp submitCacheMessage start");
        Iterator<PrioritizedRequestMessage> iterator = processingMsgList.iterator();
        while (iterator.hasNext()) {

            PrioritizedRequestMessage msg = iterator.next();
//            Utils.loge("processingMsgList.hasNext()--"+msg.evenId);
            cacheQueue.offer(msg);
        }
        processingMsgList.clear();
//        cacheQueue.addAll(TcpRequestUtil.tcpCacheQueue) ;
//        TcpRequestUtil.tcpCacheQueue.clear();
        while (Connection.getInstance().IS_LOGIN_SUCCESS&&cacheQueue.size()>0) {
            PrioritizedRequestMessage msg = cacheQueue.poll();
            Utils.loge("submit cacheQueue==---"+msg.evenId);
            submitMsg(msg);
        }
    }


    private  void submitMsg(final PrioritizedRequestMessage message){
        processingMsgList.add(message);
// 走长连接
            ChannelFuture future = Connection.getInstance().getChanel().writeAndFlush(message.getBusinessMessage());

            future.addListener(new ChannelFutureListener() {
                @Override
                public void operationComplete(ChannelFuture voidFuture) throws Exception {
                    channelFutureMap.remove(message.evenId);
                    if (!voidFuture.isSuccess()) {
                        Utils.loge("voidFuture.unSuccess()" + message.evenId);
                        // 发送失败则由处理中放到发送失败队列
                        processingMsgList.remove(message);
                        cacheQueue.offer(message);
                    }
                }

            });
            channelFutureMap.put(message.evenId,future);


    }
    private   final class TakeRequestTask implements Runnable {
        public void run(){
            while(true){
                try {
                    PrioritizedRequestMessage message =  requestQueue.take();

//                    Utils.loge("requestQueue.take()==---"+message.evenId);
                    submitMsg(message);
                } catch (InterruptedException e) {
                    Utils.loge("TakeRequestTask--end");
                    break;
                }
            }


        }
    }

    /**
     * 去除请求消息记录
     * @param requestId
     */
    @Override
    public  void onFinishRequest(int requestId){
//       processingMsgMap.remove(requestId);
        processingMsgList.remove(new PrioritizedRequestMessage(requestId));

//       channelFutureMap.remove(requestId);

    }

    /**
     * 取消请求
     * @param requestId
     */
    @Override
    public  void cancelRequest(int requestId){
        PrioritizedRequestMessage temp = new PrioritizedRequestMessage(requestId);
        cacheQueue.remove(temp);
        requestQueue.remove(temp);
//        failRequestQueue.remove(temp);
        ChannelFuture future = channelFutureMap.get(requestId);
        if(future!=null){
            future.cancel(true);
        }
        channelFutureMap.remove(requestId);
        onFinishRequest(requestId);
        // 去掉回调记录
        BaseTsp baseTsp =  BaseTsp.requestMap.get(requestId);
        if(baseTsp!=null){
            baseTsp.removeCallbackMap(requestId);
        }
    }
    @Override
    public  void clearStorage(){
        cacheQueue.clear();
        requestQueue.clear();
        processingMsgList.clear();
        channelFutureMap.clear();
        BaseTsp.requestMap.clear();
        if(thread!=null){
            thread.interrupt();
            thread = null;
        }
    }

    public   void reConnection(){
        Connection.getInstance().restart();
        channelFutureMap.clear();
    }

}
