package com.mxnavi.tspv2.core.netty;

import com.mxnavi.tspv2.core.Connection;
import com.mxnavi.tspv2.core.MessageBuilder;
import com.mxnavi.tspv2.core.RequestDispathUtil;
import com.mxnavi.tspv2.core.message.MxNGTPMessage;
import com.mxnavi.tspv2.tsp.TSP;
import com.mxnavi.tspv2.utils.Utils;

import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

/**
 * Created by Administrator on 2016/3/29.
 */
public class LoginAuthReqHandler extends SimpleChannelInboundHandler {

    public void channelActive(ChannelHandlerContext ctx) throws Exception {
        ctx.writeAndFlush(MessageBuilder.instance().makeLoginMessage());
        Utils.loge(" cchannelActive=====" );
    }

    public void channelRead0(ChannelHandlerContext ctx, Object msg) throws Exception {
        MxNGTPMessage.MxMessage mxMessage = (MxNGTPMessage.MxMessage)msg;
        MxNGTPMessage.NGTPDispatcherData dispatcherData = mxMessage.getNgtpMessage().getDispatcherData();
        MxNGTPMessage.DSPTMessageType DSPTMessageType = dispatcherData.getDsptMessageType();
        // 通知和登录的eventId相同
        if(dispatcherData.getEventId() == MessageBuilder.instance().LOGIN_EVENT_ID){// 返回登录或者通知信息
            if(DSPTMessageType.getNumber()==MxNGTPMessage.DSPTMessageType.LOGIN_ACK.getNumber()){//登录成功
                Connection.getInstance().IS_LOGIN_SUCCESS = true;
                RequestDispathUtil.submitCacheMessage(1);
//                TcpRequestUtil.tcpRequestHandler.submitCacheMessage();
                Utils.loge("TSPSDK-长连接登录成功-----");
                if (TSP.tspLoginListener != null){
                    TSP.tspLoginListener.onTSPLoginSuccess();
                }
                ctx.fireChannelRead(msg);
            }else if(dispatcherData.getDsptMessageType().getNumber() ==  MxNGTPMessage.DSPTMessageType.NOTIFICATION.getNumber()){// 通知
            	ctx.fireChannelRead(msg);
            }else if(dispatcherData.hasErrorCode()){// 登录失败
                Utils.loge("TSPSDK-长连接登录失败--"+dispatcherData.toString());
                ctx.close();
            }else{
            	ctx.fireChannelRead(msg);
            }
        }else{
            ctx.fireChannelRead(msg);
        }


    }
    @Override

    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause)throws Exception {

    	 Utils.loge("----exceptionCaught------"+cause.getMessage());

        ctx.fireExceptionCaught(cause);

    }




}
