package com.mxnavi.tspv2.drivingrecord.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.LatLng;

/**
 * Created by Administrator on 2016/4/1.
 * 请求下载视频文件返回结果
 */
public class DownloadMediaRequestResult implements Parcelable {
    String deviceNo;
    String filePath;
    String thumbnailPath;
    int lonlatType;
    LatLng position = new LatLng();
    int uploadTime;
    int recordType;

    public DownloadMediaRequestResult() {
    }

    /**
     * 取得设备唯一标识（非必传）
     * @return
     */
    public String getDeviceNo() {
        return deviceNo;
    }

    /**
     * 设置设备唯一标识（非必传）
     * @param deviceNo
     */
    public void setDeviceNo(String deviceNo) {
        this.deviceNo = deviceNo;
    }
    /**
     * 取得结果信息中又拍云地址（非必传）
     * @return
     */
    public String getFilePath() {
        return filePath;
    }

    /**
     *设置结果信息中又拍云地址（非必传）
     * @param filePath
     */
    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }
    /**
     * 取得结果信息中又拍云地址（非必传）
     * @return
     */
    public String getThumbnailPath() {
        return thumbnailPath;
    }

    /**
     * 设置结果信息中又拍云地址（非必传）
     * @param thumbnailPath
     */
    public void setThumbnailPath(String thumbnailPath) {
        this.thumbnailPath = thumbnailPath;
    }

    /**
     * 获取经纬度协议（非必传）
     * @return 0: GPS经纬度 1: 美行经纬度
     */
    public int getLonlatType() {
        return lonlatType;
    }

    /**
     *设置经纬度协议（非必传）
     * @param lonlatType 0: GPS经纬度 1: 美行经纬度
     */
    public void setLonlatType(int lonlatType) {
        this.lonlatType = lonlatType;
    }

    /**
     *获取经纬度（非必传）
     * @return
     */
    public LatLng getPosition() {
        return position;
    }

    /**
     *设置经纬度（非必传）
     * @param position
     */
    public void setPosition(LatLng position) {
        this.position = position;
    }

    /**
     *获取视频上传时间（非必传）
     * @return 格式为：UNIX时间戳
     */
    public int getUploadTime() {
        return uploadTime;
    }

    /**
     *设置视频上传时间（非必传）
     * @param uploadTime 格式为：UNIX时间戳
     */
    public void setUploadTime(int uploadTime) {
        this.uploadTime = uploadTime;
    }

    /**
     *获取 保护录影类型：手动保护录影，停车保护录影（非必传）
     * @return (0: 手动保护录影，1: 停车保护录影)
     */
    public int getRecordType() {
        return recordType;
    }

    /**
     *设置  保护录影类型：手动保护录影，停车保护录影（非必传）
     * @param recordType (0: 手动保护录影，1: 停车保护录影)
     */
    public void setRecordType(int recordType) {
        this.recordType = recordType;
    }


    protected DownloadMediaRequestResult(Parcel in) {
         deviceNo = in.readString();
         filePath = in.readString();
         thumbnailPath = in.readString();
         lonlatType = in.readInt();
         position = in.readParcelable(LatLng.class.getClassLoader());
         uploadTime = in.readInt();
         recordType = in.readInt();
    }
    public static final Creator<DownloadMediaRequestResult> CREATOR = new Creator<DownloadMediaRequestResult>() {
        @Override
        public DownloadMediaRequestResult createFromParcel(Parcel in) {
            return new DownloadMediaRequestResult(in);
        }

        @Override
        public DownloadMediaRequestResult[] newArray(int size) {
            return new DownloadMediaRequestResult[size];
        }
    };
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(deviceNo);
        dest.writeString(filePath);
        dest.writeString(thumbnailPath);
        dest.writeInt(lonlatType);
        dest.writeParcelable(position,flags);
        dest.writeInt(uploadTime);
        dest.writeInt(recordType);
    }
}
