package com.mxnavi.tspv2.drivingrecord.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.LatLng;

import java.io.File;

/**
 * Created by Administrator on 2016/4/1.
 * 上传行车记录类
 */
public class MediaInfo implements Parcelable {

    int recordType;
    int  lonlatType;
    LatLng position;
    String filename;
    String mediaFilePath;
    String thumbnailName;
    String thumbnailFilePath;

    public MediaInfo() {
    }

    /**
     * 获取录影类型
     * @return 录影类型 1: 手动上传录影，2: 碰撞上传录影，4：图片类型，8：文本类型
     */
    public int getRecordType() {
        return recordType;
    }

    /**
     * 设置录影类型
     * @param recordType 录影类型 1: 手动上传录影，2: 碰撞上传录影，4：图片类型，8：文本类型
     */
    public void setRecordType(int recordType) {
        this.recordType = recordType;
    }

    /**
     * 获取置经纬度协议类型
     * @return 经纬度协议类型 0: GPS经纬度 1: 美行经纬度
     */
    public int getLonlatType() {
        return lonlatType;
    }

    /**
     * 设置经纬度协议类型
     * @param lonlatType 经纬度协议类型 0: GPS经纬度 1: 美行经纬度
     */
    public void setLonlatType(int lonlatType) {
        this.lonlatType = lonlatType;
    }

    /**
     * 获取用户位置经纬度
     * @return 用户位置经纬度
     */
    public LatLng getPosition() {
        return position;
    }

    /**
     * 设置用户位置经纬度
     * @param position 用户位置经纬度
     */
    public void setPosition(LatLng position) {
        this.position = position;
    }

    /**
     * 获取上传文件名
     * @return 上传文件名
     */
    public String getFilename() {
        return filename;
    }

    /**
     * 设置上传文件名
     * @param filename 上传文件名
     */
    public void setFilename(String filename) {
        this.filename = filename;
    }

    /**
     * 获取缩率图文件名（非必传）
     * @return 缩率图文件名
     */
    public String getThumbnailName() {
        return thumbnailName;
    }

    /**
     * 设置缩率图文件名（非必传）
     * @param thumbnailName 缩率图文件名
     */
    public void setThumbnailName(String thumbnailName) {
        this.thumbnailName = thumbnailName;
    }

    public String getMediaFilePath() {
        return mediaFilePath;
    }

    /**
     * 设置要上传的录影文件路径
     * @param mediaFilePath
     */
    public void setMediaFilePath(String mediaFilePath) {
        this.mediaFilePath = mediaFilePath;
    }

    public String getThumbnailFilePath() {
        return thumbnailFilePath;
    }

    /**
     * 设置要上传的缩略图文件路径
     * @param thumbnailFilePath
     */
    public void setThumbnailFilePath(String thumbnailFilePath) {
        this.thumbnailFilePath = thumbnailFilePath;
    }


    protected MediaInfo(Parcel in) {
         recordType = in.readInt();
         lonlatType = in.readInt();
         position =  in.readParcelable(LatLng.class.getClassLoader());
         filename = in.readString();
         mediaFilePath = in.readString();
         thumbnailName = in.readString();
         thumbnailFilePath = in.readString();
    }
    public static final Creator<MediaInfo> CREATOR = new Creator<MediaInfo>() {
        @Override
        public MediaInfo createFromParcel(Parcel in) {
            return new MediaInfo(in);
        }

        @Override
        public MediaInfo[] newArray(int size) {
            return new MediaInfo[size];
        }
    };
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(recordType);
        dest.writeInt(lonlatType);
        dest.writeParcelable(position,flags);
        dest.writeString(filename);
        dest.writeString(mediaFilePath);
        dest.writeString(thumbnailName);
        dest.writeString(thumbnailFilePath);
    }

    
}
