package com.mxnavi.tspv2.feichuan.client.core;

import android.util.Log;

import com.mxnavi.tspv2.feichuan.client.core.listener.Connection;
import com.mxnavi.tspv2.feichuan.common.Constance;
import com.mxnavi.tspv2.feichuan.common.ExecutorManager;
import com.mxnavi.tspv2.utils.Utils;

import java.io.DataInputStream;

/**
 * Created by Administrator on 2018/1/4.
 */

public class TcpReader implements Runnable{

    final String TAG = Constance.LOG_TAG;

    final int MAXLENGTH = 1024;

    DataInputStream mDis = null;
    Connection mConnection;

    boolean isTCPStop = false;

    public TcpReader(Connection connection){
        mConnection = connection;

    }

    public void startRead(DataInputStream dis){
        Log.e(TAG,"startRead");
        mDis = dis;
        ExecutorManager.INSTANCE.getReadThread().execute(this);
    }
    public void stopRead(){

        isTCPStop = true;
        ExecutorManager.INSTANCE.getReadThread().shutdown();
    }
    @Override
    public void run() {
        Log.e(TAG,"startRead run");
        byte[] bufferBytes = new byte[MAXLENGTH];

        int readLength = 0;
        byte[] nextPackagePart = null;

        try{
            while (!isTCPStop&&(readLength = mDis.read(bufferBytes))!=-1){
                if(readLength < bufferBytes.length){
                    byte[] temp = new  byte[readLength];
                    System.arraycopy(bufferBytes,0,temp,0,readLength);
                    bufferBytes = temp;
                }
                if(nextPackagePart!=null){
                    bufferBytes = Utils.concat(nextPackagePart,bufferBytes);
                }
                while (bufferBytes.length>= Constance.HEADER_LEN&&!isTCPStop) {
                    byte type = bufferBytes[0];
                    byte[] bodyLengthBytes = new byte[4];

                    System.arraycopy(bufferBytes, 1, bodyLengthBytes, 0, 4);
                    int bodyLength = Utils.bytes2Int(bodyLengthBytes);
                    if (bufferBytes.length >= bodyLength + Constance.HEADER_LEN) {// 包含一个全包
                        if (type == Constance.STRING_PACKET_BYTE) {
                            // 解析字符串
//                            byte[] strBytes = new byte[bodyLength];
//                            System.arraycopy(bufferBytes,5,strBytes,0,bodyLength);
                            String recvMsg = Utils.decode(new String(bufferBytes, 5, bodyLength));
                            Log.e(TAG, "接收一个文本" + recvMsg);
                            mConnection.onReceiveStrMsg(recvMsg);
                        }else if(type == Constance.BYTE_PACKET_BYTE){
                            Log.e(TAG, "receive byte" );
                        }else if(type == Constance.HB_PACKET_BYTE){
                            Log.e(TAG, "receive hearbeat" );
                        }
                        int nextLength = bufferBytes.length-Constance.HEADER_LEN-bodyLength;
//                    Utils.loge("nextLength="+nextLength);
                        if(nextLength==0){
                            nextPackagePart = null;
                            // 完成解析bufferBytes
                            bufferBytes =  new byte[0];
                            break;
                        }
                        byte[] nextBytes = new byte[nextLength];
                        System.arraycopy(bufferBytes,Constance.HEADER_LEN+bodyLength,nextBytes,0,nextLength);
                        bufferBytes = nextBytes;
                    }else {//
                        nextPackagePart = bufferBytes;
                        break;
                    }

                }
                if(bufferBytes.length==0){
                    nextPackagePart = null;
                }else if(bufferBytes.length<5){
                    nextPackagePart = bufferBytes;
                }
                bufferBytes =  new byte[MAXLENGTH];
            }

        }catch (Exception e){

            e.printStackTrace();
            Log.e(TAG,"blockReadData catexception"+Log.getStackTraceString(e));

        }

        mConnection.close();
    }



}
