package com.mxnavi.tspv2.feichuan.server.core;

import android.content.Context;
import android.net.DhcpInfo;
import android.net.wifi.WifiManager;
import android.text.format.Formatter;
import android.util.Log;


import com.mxnavi.tspv2.feichuan.common.Constance;
import com.mxnavi.tspv2.feichuan.server.ServerManager;
import com.mxnavi.tspv2.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;

/**
 * Created by Administrator on 2017/12/26.
 */

public class UdpServer implements Runnable{
    String TAG = Constance.LOG_TAG;
    DatagramSocket serversocket;
    boolean isStop = false;
    int MAXLENGTH = 1024*5;
    final int MAGNO_BROADCAST = 1;
    final String currVer = "1.0";
    final int DEVICENO_MATHCHFAIL_MATHCH_RESULT = 3;

    String mDeviceNo;

    InetAddress conectedAddress;
    int cilentPort;

    Context mContext;
    public UdpServer(String deviceNo,Context context){
        mDeviceNo = deviceNo;
        mContext = context;
    }
    @Override
    public void run() {
        try {
            serversocket = new DatagramSocket(Constance.SERVER_UDP_PORT);
            byte[] buf ;
            DatagramPacket packet ;
            while (!isStop){
                buf = new byte[MAXLENGTH];
                packet = new DatagramPacket(buf, buf.length);
                try{
                    serversocket.receive(packet);
                }catch (IOException e){
                    e.printStackTrace();
                }

                String recvMsg = new String(buf, 0,
                        packet.getLength());
                recvMsg = Utils.decode(recvMsg);
                receiveMsg(packet,recvMsg);
            }

        }catch (SocketException e) {
            e.printStackTrace();
        }
    }

    private void receiveMsg(DatagramPacket packet,String msg){
        Log.e(TAG,"udp recevie msg:"+msg);
        JSONTokener jsonTokener = new JSONTokener(msg);
        JSONObject json = null;
        try {
            json = (JSONObject) jsonTokener.nextValue();
            int msgType = json.getInt("msgType");
        }catch (JSONException e) {
            e.printStackTrace();
        }
        try {
            int msgNo = json.getInt("msgNo");
            JSONObject sendJson;
            switch (msgNo){
                case MAGNO_BROADCAST:
                    String version = json.getString("version");
                    String deviceName = json.getString("deviceName");

                    String bindCarId = json.getString("bindCarId");
                    conectedAddress = packet.getAddress();
                    String address= conectedAddress.getHostAddress().toString();
                     Log.e(TAG,"收到广播地址："+address);
                     if(!address.equals(getWifiPotIp())){
                         Log.e(TAG,"收到广播地址和热点地址不同");
                        return;
                     }
                    Log.e(TAG,"收到广播地址和热点地址相同");
                    cilentPort = packet.getPort();
                    int matchResult = -1;

                    JSONArray pttVer = json.getJSONArray("ptt");
                    Log.e(TAG,"收到广播地址和热点地址相同");
                    int currVerInt = Integer.valueOf(currVer.replace(".",""));
                    Log.e(TAG,"currVerInt="+currVerInt);
                    for(int i=0;i<pttVer.length();i++){
                        String ver = pttVer.getString(i);
                        if(currVer.equals(ver)){
                            matchResult = Constance.SUCCESS_MATHCH_RESULT;
                            break;
                        }else{
                            if(currVerInt<(Integer.valueOf(ver.replace("\\.","")))){
                                matchResult = Constance.CAR_LOWER_MATHCH_RESULT;
                            }else{
                                matchResult = Constance.CAR_HIGHER_MATHCH_RESULT;
                            }
                        }
                    }
                    Log.e(TAG,"matchResult="+matchResult);
                    JSONObject respObj = new JSONObject();
                    respObj.put("msgType",1);
                    respObj.put("msgNo",1);
                    respObj.put("matchResult",matchResult);
                    respObj.put("ptt",currVer);
                    respObj.put("carId","");
                    if(matchResult == Constance.SUCCESS_MATHCH_RESULT){
                        respObj.put("serverPort", ServerManager.getInstance().getTcpPort());
                    }else{

                    }

                    sendMsg(respObj.toString());


//                    receiveDataListener.onReceiveBroadCast(msg);

                    break;


            }

        }catch (Exception e){
            e.printStackTrace();
        }

    }
    private void sendMsg(String msg) throws IOException{
        msg = Utils.encode(msg);
        byte[] buf = msg.getBytes();
        DatagramPacket mBRDPacket = new DatagramPacket(buf, buf.length,conectedAddress,cilentPort);
        serversocket.send(mBRDPacket);
        Log.e(TAG,"sendMsg"+msg);

    }

    public String getWifiPotIp(){
//        getIPAddress(getApplicationContext());
        WifiManager wifiManager = (WifiManager) (mContext.getSystemService(Context.WIFI_SERVICE));
        DhcpInfo info = wifiManager.getDhcpInfo();
        String hotIp = Formatter.formatIpAddress(info.serverAddress);
        Log.e(TAG,"热点地址："+hotIp);
        return hotIp;

    }

}



