package com.mxnavi.tspv2.flowcontrol.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by Administrator on 2018/3/29.
 */

public class FlowInfo implements Parcelable,Serializable {
    String applicationId;
    String applicationName;
    String usedFlow;
    String totalFlow;
    String effectiveDate;
    String effectiveLeftDate;
    String freeEffectiveDate;
    String freeLeftDays;

    public FlowInfo() {
    }

    protected FlowInfo(Parcel in) {
        applicationId = in.readString();
        applicationName = in.readString();
        usedFlow = in.readString();
        totalFlow = in.readString();
        effectiveDate = in.readString();
        effectiveLeftDate = in.readString();
        freeEffectiveDate = in.readString();
        freeLeftDays = in.readString();
    }

    public static final Creator<FlowInfo> CREATOR = new Creator<FlowInfo>() {
        @Override
        public FlowInfo createFromParcel(Parcel in) {
            return new FlowInfo(in);
        }

        @Override
        public FlowInfo[] newArray(int size) {
            return new FlowInfo[size];
        }
    };

    /**
     * 获取应用ID
     * @return
     */
    public String getApplicationId() {
        return applicationId;
    }

    /**
     * 设置应用ID
     * @param applicationId
     */
    public void setApplicationId(String applicationId) {
        this.applicationId = applicationId;
    }

    /**
     * 获取应用名称
     * @return
     */
    public String getApplicationName() {
        return applicationName;
    }

    /**
     * 设置应用名称
     * @param applicationName
     */
    public void setApplicationName(String applicationName) {
        this.applicationName = applicationName;
    }

    /**
     * 获取使用流量
     * @return
     */
    public String getUsedFlow() {
        return usedFlow;
    }

    /**
     * 设置使用流量
     * @param usedFlow
     */
    public void setUsedFlow(String usedFlow) {
        this.usedFlow = usedFlow;
    }

    /**
     * 获取总流量
     * @return
     */
    public String getTotalFlow() {
        return totalFlow;
    }

    /**
     * 设置总流量
     * @param totalFlow
     */
    public void setTotalFlow(String totalFlow) {
        this.totalFlow = totalFlow;
    }

    /**
     * 获取有效期，是指流量的到期时间
     * @return
     */
    public String getEffectiveDate() {
        return effectiveDate;
    }

    /**
     * 设置有效期，是指流量的到期时间
     * @param effectiveDate
     */
    public void setEffectiveDate(String effectiveDate) {
        this.effectiveDate = effectiveDate;
    }

    /**
     * 获取有效期剩余时间>=0在有效期，<0 过期
     * @return
     */
    public String getEffectiveLeftDate() {
        return effectiveLeftDate;
    }

    /**
     * 设置有效期剩余时间>=0在有效期，<0 过期
     * @param effectiveLeftDate
     */
    public void setEffectiveLeftDate(String effectiveLeftDate) {
        this.effectiveLeftDate = effectiveLeftDate;
    }

    /**
     * 获取免流量的有效期（到期时间）
     * @return
     */
    public String getFreeEffectiveDate() {
        return freeEffectiveDate;
    }

    /**
     * 设置免流量的有效期（到期时间）
     * @param freeEffectiveDate
     */
    public void setFreeEffectiveDate(String freeEffectiveDate) {
        this.freeEffectiveDate = freeEffectiveDate;
    }

    /***
     * 获取剩余的免流量时间，0代表截止到今天24:00,1代表还有两天到期，2代表还有三天到期，负数表示超过了免流量有效期，当超过了免流量有效期需要使用effective_date来做有效期
     * @return
     */
    public String getFreeLeftDays() {
        return freeLeftDays;
    }

    /**
     * 设置剩余的免流量时间，0代表截止到今天24:00,1代表还有两天到期，2代表还有三天到期，负数表示超过了免流量有效期，当超过了免流量有效期需要使用effective_date来做有效期
     * @param freeLeftDays
     */
    public void setFreeLeftDays(String freeLeftDays) {
        this.freeLeftDays = freeLeftDays;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(applicationId);
        parcel.writeString(applicationName);
        parcel.writeString(usedFlow);
        parcel.writeString(totalFlow);
        parcel.writeString(effectiveDate);
        parcel.writeString(effectiveLeftDate);
        parcel.writeString(freeEffectiveDate);
        parcel.writeString(freeLeftDays);
    }
}
