package com.mxnavi.tspv2.fm.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class Album implements Parcelable,Serializable {
    String id;
    String title;
    AlbumTagIconUrl iconUrl;
    String intro;
    String authorName;
    String authorId;
    int soundsCount;
    int playsCount;
    String updateTime;
    public Album() {
    }
    protected Album(Parcel in){
        id = in.readString();
        title = in.readString();
        iconUrl = in.readParcelable(AlbumTagIconUrl.class.getClassLoader());
        intro = in.readString();
        authorName = in.readString();
        authorId = in.readString();
        soundsCount = in.readInt();
        playsCount = in.readInt();
        updateTime = in.readString();
    }
    public static final Creator<Album> CREATOR = new Creator<Album>() {
        @Override
        public Album createFromParcel(Parcel in) {
            return new Album(in);
        }

        @Override
        public Album[] newArray(int size) {
            return new Album[size];
        }
    };


    /**
     * 获取专辑播放次数
     * @return
     */
    public int getPlaysCount() {
        return playsCount;
    }

    public void setPlaysCount(int playsCount) {
        this.playsCount = playsCount;
    }

    /**
     * 获取专辑标签的图标，分为大、中、小三种图标
     * @return
     */
    public AlbumTagIconUrl getIconUrl() {
        return iconUrl;
    }

    public void setIconUrl(AlbumTagIconUrl iconUrl) {
        this.iconUrl = iconUrl;
    }

    /**
     * 获取专辑介绍
     * @return
     */
    public String getIntro() {
        return intro;
    }

    public void setIntro(String intro) {
        this.intro = intro;
    }
    /**
     * 获取主播名称
     * @return
     */
    public String getAuthorName() {
        return authorName;
    }

    public void setAuthorName(String authorName) {
        this.authorName = authorName;
    }
    /**
     * 获取主播id
     * @return
     */
    public String getAuthorId() {
        return authorId;
    }

    public void setAuthorId(String authorId) {
        this.authorId = authorId;
    }
    /**
     * 获取专辑的声音数
     * @return
     */
    public int getSoundsCount() {
        return soundsCount;
    }

    public void setSoundsCount(int soundsCount) {
        this.soundsCount = soundsCount;
    }
    /**
     * 获取专辑名称
     * @return
     */
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }
    /**
     * 获取专辑ID
     * @return
     */
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }
    /**
     * 获取专辑的最后更新时间
     * @return
     */
    public String getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(String updateTime) {
        this.updateTime = updateTime;
    }
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(id);
        dest.writeString(title);
        dest.writeParcelable(iconUrl, flags);
        dest.writeString(intro);
        dest.writeString(authorName);
        dest.writeString(authorId);
        dest.writeInt(soundsCount);
        dest.writeInt(playsCount);
        dest.writeString(updateTime);
    }
}
