package com.mxnavi.tspv2.fm.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;
import java.util.List;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class AlbumsResult  implements Parcelable,Serializable {
    /**
     * nextLevel:下一级内容
     * albums:专辑列表
     */
    int nextLevel;
    List<Album> albums;
    int allCount;

    public AlbumsResult() {
    }

    protected AlbumsResult(Parcel in) {
        nextLevel = in.readInt();
        albums =in .createTypedArrayList(Album.CREATOR);
        allCount = in.readInt();
    }

    public static final Creator<AlbumsResult> CREATOR = new Creator<AlbumsResult>() {
        @Override
        public AlbumsResult createFromParcel(Parcel in) {
            return new AlbumsResult(in);
        }

        @Override
        public AlbumsResult[] newArray(int size) {
            return new AlbumsResult[size];
        }
    };

    /**
     * 获取 检索总条数
     * @return
     */
    public int getAllCount() {
        return allCount;
    }

    /**
     *设置 检索总条数
     * @param allCount
     */
    public void setAllCount(int allCount) {
        this.allCount = allCount;
    }

    /**
     * 获取下一级内容
     * @return
     */
    public int getNextLevel() {
        return nextLevel;
    }

    public void setNextLevel(int nextLevel) {
        this.nextLevel = nextLevel;
    }

    /**
     * 获取专辑列表
     * @return
     */
    public List<Album> getAlbums() {
        return albums;
    }

    public void setAlbums(List<Album> albums) {
        this.albums = albums;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(nextLevel);
        dest.writeTypedList(albums);
        dest.writeInt(allCount);
    }
}
