package com.mxnavi.tspv2.fm.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;
import java.util.List;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class CategoriesResult implements Parcelable,Serializable {
    int nextLevel;
    List<Category> categories;

    public CategoriesResult() {
    }

    protected CategoriesResult(Parcel in) {
        nextLevel = in.readInt();
        categories = in.createTypedArrayList(Category.CREATOR);
    }

    public static final Creator<CategoriesResult> CREATOR = new Creator<CategoriesResult>() {
        @Override
        public CategoriesResult createFromParcel(Parcel in) {
            return new CategoriesResult(in);
        }

        @Override
        public CategoriesResult[] newArray(int size) {
            return new CategoriesResult[size];
        }
    };
    /**
     * 获取下一级内容（2:tag，3:专辑）
     * @return
     */
    public int getNextLevel() {
        return nextLevel;
    }
    /**
     * 设置下一级内容（2:tag，3:专辑）
     * @return
     */
    public void setNextLevel(int nextLevel) {
        this.nextLevel = nextLevel;
    }
    /**
     * 获取所有的分类列表
     * @return
     */
    public List<Category> getCategories() {
        return categories;
    }
    /**
     * 设置所有的分类列表
     * @return
     */
    public void setCategories(List<Category> categories) {
        this.categories = categories;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(nextLevel);
        dest.writeTypedList(categories);
    }
}
