package com.mxnavi.tspv2.fm.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by Administrator on 2016/4/21.
 * desc
 */
public class MediaInfo  implements Parcelable,Serializable {
    String id;
    String title;
    AlbumTagIconUrl iconUrl;
    Mp3Info mp3;
    int duration;
    String authorName;
    String authorId;
    int playsCount;
    int commentsCount;
    int favoritesCount;
    String createdTime;
    String albumId;

    public MediaInfo() {
    }
    protected MediaInfo(Parcel in) {
        id = in.readString();
        title = in.readString();
        iconUrl = in.readParcelable(AlbumTagIconUrl.class.getClassLoader());
        mp3 = in.readParcelable(Mp3Info.class.getClassLoader());
        duration = in.readInt();
        authorName = in.readString();
        authorId = in.readString();
        playsCount = in.readInt();
        commentsCount = in.readInt();
        favoritesCount = in.readInt();
        createdTime = in.readString();
        albumId = in.readString();
    }

    public static final Creator<MediaInfo> CREATOR = new Creator<MediaInfo>() {
        @Override
        public MediaInfo createFromParcel(Parcel in) {
            return new MediaInfo(in);
        }

        @Override
        public MediaInfo[] newArray(int size) {
            return new MediaInfo[size];
        }
    };
    /**
     * 获取声音id
     * @return
     */
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }
    /**
     * 获取声音名称
     * @return
     */
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }
    /**
     * 获取声音的图标，分为大、中、小三种图标
     * @return
     */
    public AlbumTagIconUrl getIconUrl() {
        return iconUrl;
    }

    public void setIconUrl(AlbumTagIconUrl iconUrl) {
        this.iconUrl = iconUrl;
    }
    /**
     * 获取mp3格式的声音地址
     * @return
     */
    public Mp3Info getMp3() {
        return mp3;
    }

    public void setMp3(Mp3Info mp3) {
        this.mp3 = mp3;
    }
    /**
     * 获取声音时长，单位秒
     * @return
     */
    public int getDuration() {
        return duration;
    }

    public void setDuration(int duration) {
        this.duration = duration;
    }
    /**
     * 获取主播名称
     * @return
     */
    public String getAuthorName() {
        return authorName;
    }

    public void setAuthorName(String authorName) {
        this.authorName = authorName;
    }
    /**
     * 获取主播id
     * @return
     */
    public String getAuthorId() {
        return authorId;
    }

    public void setAuthorId(String authorId) {
        this.authorId = authorId;
    }
    /**
     * 获取播放次数
     * @return
     */
    public int getPlaysCount() {
        return playsCount;
    }

    public void setPlaysCount(int playsCount) {
        this.playsCount = playsCount;
    }
    /**
     * 获取评论次数
     * @return
     */
    public int getCommentsCount() {
        return commentsCount;
    }

    public void setCommentsCount(int commentsCount) {
        this.commentsCount = commentsCount;
    }
    /**
     * 获取喜欢次数
     * @return
     */
    public int getFavoritesCount() {
        return favoritesCount;
    }

    public void setFavoritesCount(int favoritesCount) {
        this.favoritesCount = favoritesCount;
    }
    /**
     * 获取声音的创建时间
     * @return
     */
    public String getCreatedTime() {
        return createdTime;
    }

    public void setCreatedTime(String createdTime) {
        this.createdTime = createdTime;
    }

    /**
     * 获取声音所属专辑ID
     * @return
     */
    public String getAlbumId() {
        return albumId;
    }

    public void setAlbumId(String albumId) {
        this.albumId = albumId;
    }


    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(id);
        dest.writeString(title);
        dest.writeParcelable(iconUrl, flags);
        dest.writeParcelable(mp3, flags);
        dest.writeInt(duration);
        dest.writeString(authorName);
        dest.writeString(authorId);
        dest.writeInt(playsCount);
        dest.writeInt(commentsCount);
        dest.writeInt(favoritesCount);
        dest.writeString(createdTime);
        dest.writeString(albumId);

    }
}
