package com.mxnavi.tspv2.fm.model;

import java.util.List;

/**
 * 直播的节目信息
 */

public class ProgramInfo {
    int id;
    String kind;
    String programName;
    String backPicUrl;
    String rate24AacUrl;
    String rate64AacUrl;
    String rate24TsUrl;
    String rate64TsUrl;
    List<Integer> supportBitrates;
    List<LiveAnnouncer>liveAnnouncers;
    long updatedAt;

    /**
     * 返回直播节目ID
     * @return
     */
    public int getId() {
        return id;
    }

    /**
     * 设置直播节目ID
     * @param id
     */
    public void setId(int id) {
        this.id = id;
    }

    /**
     * 返回数据类型，固定值"program "
     * @return
     */
    public String getKind() {
        return kind;
    }

    /**
     * 设置数据类型，固定值"program "
     * @param kind
     */
    public void setKind(String kind) {
        this.kind = kind;
    }

    /**
     *  返回直播节目名称
     * @return
     */
    public String getProgramName() {
        return programName;
    }

    /**
     *  设置直播节目名称
     * @param programName
     */
    public void setProgramName(String programName) {
        this.programName = programName;
    }

    /**
     * 返回节目背景图URL
     * @return
     */
    public String getBackPicUrl() {
        return backPicUrl;
    }

    /**
     * 设置节目背景图URL
     * @param backPicUrl
     */
    public void setBackPicUrl(String backPicUrl) {
        this.backPicUrl = backPicUrl;
    }

    /**
     * 返回24码率aac格式播放地址
     * @return
     */
    public String getRate24AacUrl() {
        return rate24AacUrl;
    }

    /**
     * 设置24码率aac格式播放地址
     * @param rate24AacUrl
     */
    public void setRate24AacUrl(String rate24AacUrl) {
        this.rate24AacUrl = rate24AacUrl;
    }

    /**
     * 返回64码率aac格式播放地址
     * @return
     */
    public String getRate64AacUrl() {
        return rate64AacUrl;
    }

    /**
     * 设置64码率aac格式播放地址
     * @param rate64AacUrl
     */
    public void setRate64AacUrl(String rate64AacUrl) {
        this.rate64AacUrl = rate64AacUrl;
    }

    /**
     * 返回24码率ts格式播放地址
     * @return
     */
    public String getRate24TsUrl() {
        return rate24TsUrl;
    }

    /**
     * 设置24码率ts格式播放地址
     * @param rate24TsUrl
     */
    public void setRate24TsUrl(String rate24TsUrl) {
        this.rate24TsUrl = rate24TsUrl;
    }

    /**
     * 返回64码率ts格式播放地址
     * @return
     */
    public String getRate64TsUrl() {
        return rate64TsUrl;
    }

    /**
     * 设置64码率ts格式播放地址
     * @param rate64TsUrl
     */
    public void setRate64TsUrl(String rate64TsUrl) {
        this.rate64TsUrl = rate64TsUrl;
    }

    /**
     * 返回支持的码率列表
     * @return
     */
    public List<Integer> getSupportBitrates() {
        return supportBitrates;
    }

    /**
     * 设置支持的码率列表
     * @param supportBitrates
     */
    public void setSupportBitrates(List<Integer> supportBitrates) {
        this.supportBitrates = supportBitrates;
    }

    /**
     * 返回直播主播列表
     * @return
     */
    public List<LiveAnnouncer> getLiveAnnouncers() {
        return liveAnnouncers;
    }

    /**
     * 设置直播主播列表
     * @param liveAnnouncers
     */
    public void setLiveAnnouncers(List<LiveAnnouncer> liveAnnouncers) {
        this.liveAnnouncers = liveAnnouncers;
    }

    /**
     * 返回节目更新时间，单位为毫秒
     * @return
     */
    public long getUpdatedAt() {
        return updatedAt;
    }

    /**
     * 设置节目更新时间，单位为毫秒
     * @param updatedAt
     */
    public void setUpdatedAt(long updatedAt) {
        this.updatedAt = updatedAt;
    }
}
