package com.mxnavi.tspv2.fm.model;

import java.util.List;

/**
 * 某个直播电台某一天的节目排期信息
 */

public class Schedule {
    int id;
    String startTime;
    String endTime;
    int radioId;
    ProgramInfo relatedProgram;
    int playType;
    String listenBackUrl;
    long updatedAt;

    /**
     * 获取节目时间表ID
     * @return
     */
    public int getId() {
        return id;
    }

    /**
     * 设置节目时间表ID
     * @param id
     */
    public void setId(int id) {
        this.id = id;
    }


    /**
     * 获取节目开始时间
     * @return
     */
    public String getStartTime() {
        return startTime;
    }

    /**
     * 设置节目开始时间
     * @param startTime
     */
    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    /**
     * 获取节目结束时间
     * @return
     */
    public String getEndTime() {
        return endTime;
    }

    /**
     * 设置节目结束时间
     * @param endTime
     */
    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    /**
     * 获取电台ID
     * @return
     */
    public int getRadioId() {
        return radioId;
    }

    /**
     * 设置电台ID
     * @param radioId
     */
    public void setRadioId(int radioId) {
        this.radioId = radioId;
    }

    /**
     * 获取关联的直播节目
     * @return
     */
    public ProgramInfo getRelatedProgram() {
        return relatedProgram;
    }

    /**
     * 设置关联的直播节目
     * @param relatedProgram
     */
    public void setRelatedProgram(ProgramInfo relatedProgram) {
        this.relatedProgram = relatedProgram;
    }

    /**
     * 获取播放类型0-直播，1-重播，2-跨天，3-无流期
     * @return
     */
    public int getPlayType() {
        return playType;
    }

    /**
     * 设置播放类型0-直播，1-重播，2-跨天，3-无流期
     * @param playType
     */
    public void setPlayType(int playType) {
        this.playType = playType;
    }

    /**
     * 获取节目回听地址
     * @return
     */
    public String getListenBackUrl() {
        return listenBackUrl;
    }

    /**
     * 设置节目回听地址
     * @param listenBackUrl
     */
    public void setListenBackUrl(String listenBackUrl) {
        this.listenBackUrl = listenBackUrl;
    }

    /**
     * 获取更新时间，单位为毫秒
     * @return
     */
    public long getUpdatedAt() {
        return updatedAt;
    }

    /**
     * 设置更新时间，单位为毫秒
     * @param updatedAt
     */
    public void setUpdatedAt(long updatedAt) {
        this.updatedAt = updatedAt;
    }
}
