package com.mxnavi.tspv2.gasstation.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.LatLng;

import java.util.List;

/**
 * Created by lenovo on 2016/10/17.
 */
public class GasStationInfoById implements Cloneable,Parcelable {
    String id;
    String name;
    String areaName;
    String address;
    String brandName;
    String type;
    String discount;
    String exhaust;
    LatLng location;
    List<GasPrice> gasOlinePrice;
    List<GasPrice> dieselOilPrice;
    List<GasPrice> naturalGasPrice;
    List<GasPrice> otherPrice;
    String fwlsmc;

    public GasStationInfoById() {
    }

    protected GasStationInfoById(Parcel in) {
        id = in.readString();
        name = in.readString();
        areaName = in.readString();
        address = in.readString();
        brandName = in.readString();
        type = in.readString();
        discount = in.readString();
        exhaust = in.readString();
        location = in.readParcelable(LatLng.class.getClassLoader());
        fwlsmc = in.readString();
    }

    public static final Creator<GasStationInfoById> CREATOR = new Creator<GasStationInfoById>() {
        @Override
        public GasStationInfoById createFromParcel(Parcel in) {
            return new GasStationInfoById(in);
        }

        @Override
        public GasStationInfoById[] newArray(int size) {
            return new GasStationInfoById[size];
        }
    };

    /**
     * 获取加油站ID（不存在返回-1）
     * @return
     */
    public String getId() {
        return id;
    }

    /**
     * 设置加油站ID（不存在返回-1）
     * @param id
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * 获取名称（不存在返回“”）
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * 设置名称（不存在返回“”）
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * 获取区位（不存在返回“”）
     * @return
     */
    public String getAreaname() {
        return areaName;
    }

    /**
     * 设置区位（不存在返回“”）
     * @param areaname
     */
    public void setAreaname(String areaname) {
        this.areaName = areaname;
    }

    /**
     * 获取详细地址（不存在返回“”）
     * @return
     */
    public String getAddress() {
        return address;
    }

    /**
     * 设置详细地址（不存在返回“”）
     * @param address
     */
    public void setAddress(String address) {
        this.address = address;
    }

    /**
     * 获取运营商（不存在返回“”）
     * @return
     */
    public String getBrandname() {
        return brandName;
    }

    /**
     * 设置运营商（不存在返回“”）
     * @param brandname
     */
    public void setBrandname(String brandname) {
        this.brandName = brandname;
    }

    /**
     * 获取加油站类别（不存在返回“”）
     * @return
     */
    public String getType() {
        return type;
    }

    /**
     * 设置加油站类别（不存在返回“”）
     * @param type
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * 获取是否打折（不存在返回“”）
     * @return
     */
    public String getDiscount() {
        return discount;
    }

    /**
     * 设置是否打折（不存在返回“”）
     * @param discount
     */
    public void setDiscount(String discount) {
        this.discount = discount;
    }

    /**
     * 获取获取尾气排放标准（不存在返回“”）
     * @return
     */
    public String getExhaust() {
        return exhaust;
    }

    /**
     * 设置获取尾气排放标准（不存在返回“”）
     * @param exhaust
     */
    public void setExhaust(String exhaust) {
        this.exhaust = exhaust;
    }

    /**
     * 获取加油站位置
     * @return
     */
    public LatLng getLocation() {
        return location;
    }

    /**
     * 设置加油站位置
     * @param location
     */
    public void setLocation(LatLng location) {
        this.location = location;
    }

    /**
     * 获取加油站汽油油价
     * @return
     */
    public List<GasPrice> getGasolinePrice() {
        return gasOlinePrice;
    }

    /**
     * 设置加油站汽油油价
     * @param gasolinePrice
     */
    public void setGasolinePrice(List<GasPrice> gasolinePrice) {
        this.gasOlinePrice = gasolinePrice;
    }

    /**
     * 获取加油站柴油油价
     * @return
     */
    public List<GasPrice> getDieselOilPrice() {
        return dieselOilPrice;
    }

    /**
     * 设置加油站柴油油价
     * @param dieselOilPrice
     */
    public void setDieselOilPrice(List<GasPrice> dieselOilPrice) {
        this.dieselOilPrice = dieselOilPrice;
    }

    /**
     * 获取加油站天然气油价
     * @return
     */
    public List<GasPrice> getNaturalGasPrice() {
        return naturalGasPrice;
    }

    /**
     * 设置加油站天然气油价
     * @param naturalGasPrice
     */
    public void setNaturalGasPrice(List<GasPrice> naturalGasPrice) {
        this.naturalGasPrice = naturalGasPrice;
    }

    /**
     * 获取加油站其他能源油价
     * @return
     */
    public List<GasPrice> getOtherPrice() {
        return otherPrice;
    }

    /**
     * 设置加油站其他能源油价
     * @param otherPrice
     */
    public void setOtherPrice(List<GasPrice> otherPrice) {
        this.otherPrice = otherPrice;
    }

    /**
     * 获取加油卡信息（不存在返回“”）
     * @return
     */
    public String getFwlsmc() {
        return fwlsmc;
    }

    /**
     * 设置加油卡信息（不存在返回“”）
     * @param fwlsmc
     */
    public void setFwlsmc(String fwlsmc) {
        this.fwlsmc = fwlsmc;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(id);
        dest.writeString(name);
        dest.writeString(areaName);
        dest.writeString(address);
        dest.writeString(brandName);
        dest.writeString(type);
        dest.writeString(discount);
        dest.writeString(exhaust);
        dest.writeParcelable(location, flags);
        dest.writeString(fwlsmc);
    }
}
