package com.mxnavi.tspv2.gasstation.model;

import com.mxnavi.tspv2.model.LatLng;

/**
 * Created by Administrator on 2016/4/29.
 * 通过名称检索加油站检索条件类
 */
public class SearchByNameQuery {
    LatLng cityLatLng;
    String keyword;
    LatLng location;
    int offset;
    int limit;
    String gasType;
    String gasSubtype;

    /**
     * 获取查询加油站所在的城市代表经纬度，如沈阳市的代表经纬度为市政府的经纬度
     * @return
     */
    public LatLng getCityLatLng() {
        return cityLatLng;
    }

    /**
     * 设置查询加油站所在的城市代表经纬度，如沈阳市的代表经纬度为市政府的经纬度
     * @param cityLatLng
     */
    public void setCityLatLng(LatLng cityLatLng) {
        this.cityLatLng = cityLatLng;
    }

    /**
     * 获取关键词，目前不支持首拼及拼音检索
     * @return
     */
    public String getKeyword() {
        return keyword;
    }

    /**
     * 设置关键词，目前不支持首拼及拼音检索
     * @param keyword
     */
    public void setKeyword(String keyword) {
        this.keyword = keyword;
    }

    /**
     * 获取当前位置
     * @return
     */
    public LatLng getLocation() {
        return location;
    }

    /**
     * 设置当前位置
     * @param location
     */
    public void setLocation(LatLng location) {
        this.location = location;
    }

    /**
     * 获取分页参数，从第几条开始取(默认第0条)
     * @return
     */
    public int getOffset() {
        return offset;
    }

    /**
     * 设置分页参数，从第几条开始取(默认第0条)
     * @param offset
     */
    public void setOffset(int offset) {
        this.offset = offset;
    }

    /**
     * 获取分页参数，一共取多少条(默认10条)
     * @return
     */
    public int getLimit() {
        return limit;
    }

    /**
     * 设置分页参数，一共取多少条(默认10条)
     * @param limit
     */
    public void setLimit(int limit) {
        this.limit = limit;
    }

    /**
     * 获取油种别。
     汽油:gasoline
     柴油: dieseloil
     天然: naturalgas
     其他:other
     全部：all
     （多个参数使”,”分割）
     * @return
     */
    public String getGasType() {
        return gasType;
    }

    /**
     * 设置油种别。
     汽油:gasoline
     柴油: dieseloil
     天然: naturalgas
     其他:other
     全部：all
     （多个参数使”,”分割）
     * @param gasType
     */
    public void setGasType(String gasType) {
        this.gasType = gasType;
    }

    /**
     * 获取油种别子类型。目前只支持全部
     * @return
     */
    public String getGasSubtype() {
        return gasSubtype;
    }

    /**
     * 设置油种别子类型。目前只支持全部

     * @param gasSubtype all：全部
     */
    public void setGasSubtype(String gasSubtype) {
        this.gasSubtype = gasSubtype;
    }
}
