package com.mxnavi.tspv2.model;

/**
 * Created by Administrator on 2016/3/18.
 */
public class InitializeInfo {
    private int customerKey;
    private String secretKey;
    private String vin;
    private String tsDataPath;
    private String tsConfigPath;
    private String tsConfigAssetsPath;
    private String appId;
    /**
     * 0：默认未知；1：美行车机；2：手机；3：美行后视镜；4：PC端
     */
    private int deviceType;
    private GetLatLngListener positionListener;
    public InitializeInfo(){

    }
    public InitializeInfo(int customerKey, String secretKey, String vin, int deviceType,String tsDataPath, String tsConfigPath,String tsConfigAssetsPath,GetLatLngListener position,String appId) {
        this.customerKey = customerKey;
        this.secretKey = secretKey;
        this.vin = vin;
        this.deviceType = deviceType;
        this.tsDataPath = tsDataPath;
        this.tsConfigPath = tsConfigPath;
        this.tsConfigAssetsPath = tsConfigAssetsPath;
        this.positionListener = position;
        this.appId = appId;
    }
    public interface GetLatLngListener{
        public LatLng geLatLng();
    }

    public int getCustomerKey() {
        return customerKey;
    }

    /**
     * 设置产品线ID
     * @param customerKey
     */
    public void setCustomerKey(int customerKey) {
        this.customerKey = customerKey;
    }

    public String getSecretKey() {
        return secretKey;
    }

    /**
     * 设置秘钥
     * @param secretKey
     */
    public void setSecretKey(String secretKey) {
        this.secretKey = secretKey;
    }

    public String getVin() {
        return vin;
    }

    /**
     * 设置设备ID
     * @param vin
     */
    public void setVin(String vin) {
        this.vin = vin;
    }

    public String getTsDataPath() {
        return tsDataPath;
    }

    /**
     * 设置数据存储路径
     * @param tsDataPath
     */
    public void setTsDataPath(String tsDataPath) {
        this.tsDataPath = tsDataPath;
    }

    public String getTsConfigPath() {
        return tsConfigPath;
    }

    /**
     * 设置配置文件路径
     * @param tsConfigPath
     */
    public void setTsConfigPath(String tsConfigPath) {
        this.tsConfigPath = tsConfigPath;
    }

    public GetLatLngListener getPositionListener() {
        return positionListener;
    }

    /**
     * 设置位置信息回调
     * @param positionListener
     */
    public void setPositionListener(GetLatLngListener positionListener) {
        this.positionListener = positionListener;
    }

    public int getDeviceType() {
        return deviceType;
    }

    /**
     * 设置设备类型
     * @param deviceType 0：默认未知；1：车机；2：手机；3：后视镜；4：PC端
     */
    public void setDeviceType(int deviceType) {
        this.deviceType = deviceType;
    }

    public String getTsConfigAssetsPath() {
        return tsConfigAssetsPath;
    }

    /**
     * 设置配置在APP的assets目录下的路径
     * @param tsConfigAssetsPath
     */
    public void setTsConfigAssetsPath(String tsConfigAssetsPath) {
        this.tsConfigAssetsPath = tsConfigAssetsPath;
    }

    /**
     * 设置AppId
     * @return
     */
    public String getAppId() {
        return appId;
    }

    /**
     * 获取AppId
     * @param appId
     */
    public void setAppId(String appId) {
        this.appId = appId;
    }
}
