package com.mxnavi.tspv2.model;

import java.io.Serializable;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Created by wangq on 2016/3/17.
 */
public class LatLng implements Cloneable,Parcelable,Serializable {
	private static final long serialVersionUID = 1L;
    double	latitude;
    double	longitude;



    public LatLng(double latitude, double longitude) {
        this.latitude = latitude;
        this.longitude = longitude;
    }
    public LatLng(){

    }

    protected LatLng(Parcel in) {
        latitude = in.readDouble();
        longitude = in.readDouble();
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        LatLng latLng = (LatLng) o;

        if (Double.compare(latLng.latitude, latitude) != 0) return false;
        return Double.compare(latLng.longitude, longitude) == 0;

    }

    @Override
    public int hashCode() {
        int result;
        long temp;
        temp = Double.doubleToLongBits(latitude);
        result = (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(longitude);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        return result;
    }

    /**
     * 获取纬度，单位为度
     * @return
     */
    public double getLatitude() {
        return latitude;
    }

    /**
     * 设置纬度，单位为度
     * @param latitude
     */
    public void setLatitude(double latitude) {
        this.latitude = latitude;
    }

    /**
     * 获取经度，单位为度
     * @return
     */
    public double getLongitude() {
        return longitude;
    }

    /**
     * 设置经度，单位为度
     * @param longitude
     */
    public void setLongitude(double longitude) {
        this.longitude = longitude;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {

        dest.writeDouble(latitude);
        dest.writeDouble(longitude);
    }

    public static final Creator<LatLng> CREATOR = new Creator<LatLng>() {
        @Override
        public LatLng createFromParcel(Parcel in) {
            return new LatLng(in);
        }

        @Override
        public LatLng[] newArray(int size) {
            return new LatLng[size];
        }
    };


}
