package com.mxnavi.tspv2.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

public class TspTime implements Parcelable,Serializable {
	private static final long serialVersionUID = 1L;
	/* hour, 24 */
	private int hour = 0;
	
	/* minute */
	private int min = 0;
	
	/* second */
	private int sec = 0;

	public TspTime() {
		super();
	}

	public TspTime(int hour, int min, int sec) {
		this.hour = hour;
		this.min = min;
		this.sec = sec;
	}

	protected TspTime(Parcel in) {
		hour = in.readInt();
		min = in.readInt();
		sec = in.readInt();
	}

	public static final Creator<TspTime> CREATOR = new Creator<TspTime>() {
		@Override
		public TspTime createFromParcel(Parcel in) {
			return new TspTime(in);
		}

		@Override
		public TspTime[] newArray(int size) {
			return new TspTime[size];
		}
	};

	public int getHour() {
		return hour;
	}

	public void setHour(int hour) {
		this.hour = hour;
	}

	public int getMin() {
		return min;
	}

	public void setMin(int min) {
		this.min = min;
	}

	public int getSec() {
		return sec;
	}

	public void setSec(int sec) {
		this.sec = sec;
	}

	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(hour);
		dest.writeInt(min);
		dest.writeInt(sec);
	}
}
