package com.mxnavi.tspv2.notification;



import com.mxnavi.tspv2.notification.model.DrivingRecordNotice;
import com.mxnavi.tspv2.notification.model.LoginData;
import com.mxnavi.tspv2.notification.model.MessageBindItem;
import com.mxnavi.tspv2.notification.model.MessageItem;
import com.mxnavi.tspv2.notification.model.MessagePoiItem;
import com.mxnavi.tspv2.notification.model.ReqBody;
import com.mxnavi.tspv2.notification.model.ReqHeader;

import java.util.List;

/**
 * Created by Administrator on 2016/4/15.
 * desc
 */
public interface NotificationListener{
    /**
     * 接收到poi类型的通知
     * @param weChatCarId 用户的微信账号ID
     * @param messagePoiItem
     */
  //  public void onReceiveNotice(String weChatCarId,MessagePoiItem messagePoiItem);

    /**
     * 接收到绑定或者解绑类型的通知
     * @param weChatCarId
     * @param messageBindItem
     */
  //  public void onReceiveNotice(String weChatCarId,MessageBindItem messageBindItem);

    /**
     * 接到批量的poi类型和绑定类型的通知
     * @param weChatCarId 腾讯定义的车机号
     * @param mssagePoiList size等于0表示未接到POI类型的通知
     * @param messageBindList size等于0表示未接到绑定类型的通知
     */
    public void onReceiveSendToCarNotice(String weChatCarId,List<MessagePoiItem> mssagePoiList,List<MessageBindItem> messageBindList);

    /**
     * 接到批量的推送消息
     * @param messageItems 消息体
     */
    public void onReceiveSendToCarMessage(List<MessageItem> messageItems);

    /**
     * 接收到用户登录信息的通知
     * @param loginData 登录信息
     */
    public void onReceiveUserLoginNotice(LoginData loginData);

    /**
     * 接收到行车记录仪拍照通知
     * @param drivingRecordNotice
     */
    public void onReceiveDrivingRecordNotice(DrivingRecordNotice drivingRecordNotice);

    /**
     * 接收到远程控制的通知
     * @param reqHeader
     * @param reqBody
     */
    public void onReceiveRemoteControlNotice(ReqHeader reqHeader, ReqBody reqBody);

}