package com.mxnavi.tspv2.notification.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.utils.Utils;

import org.json.JSONObject;

/**
 * Created by Administrator on 2017/9/4.
 */

public class ReqBody implements Parcelable {
    String instruction;
    int appLon;
    int appLat;
    String dataJsonStr;

    String safePasswd;

    public ReqBody(){

    }
    protected ReqBody(Parcel in) {
        instruction = in.readString();
        appLon = in.readInt();
        appLat = in.readInt();
        dataJsonStr = in.readString();
        safePasswd = in.readString();

    }
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(instruction);
        dest.writeInt(appLon);
        dest.writeInt(appLat);
        dest.writeString(dataJsonStr);
        dest.writeString(safePasswd);

    }
    public static final Creator<ReqBody> CREATOR = new Creator<ReqBody>() {
        @Override
        public ReqBody createFromParcel(Parcel in) {
            return new ReqBody(in);
        }

        @Override
        public ReqBody[] newArray(int size) {
            return new ReqBody[size];
        }
    };



    public String getInstruction() {
        return instruction;
    }

    /**
     * 设置控制指令码，详见接口文档
     * @param instruction
     */
    public void setInstruction(String instruction) {
        this.instruction = instruction;
    }

    public int getAppLon() {
        return appLon;
    }
    /**
     * 设置手机当前经度，单位是1/2560秒
     * @param appLon
     */
    public void setAppLon(int appLon) {
        this.appLon = appLon;
    }

    public int getAppLat() {
        return appLat;
    }
    /**
     * 设置手机当前纬度，单位是1/2560秒
     * @param appLat
     */
    public void setAppLat(int appLat) {
        this.appLat = appLat;
    }

    public String getDataJsonStr() {
        return dataJsonStr;
    }
    /**
     * 与instruction对应，例如空调开启，具体温度，风力等参数，在此设置，需要车机端和手机端定参数格式。具体参考车机端或手机端文档
     * @param dataJsonStr
     */
    public void setDataJsonStr(String dataJsonStr) {
        this.dataJsonStr = dataJsonStr;
    }

    public String getSafePasswd() {
        return safePasswd;
    }

    /**
     * 设置安防密码，是未进行MD5加密的，SDK会自行加密
     * @param safePasswd
     */
    public void setSafePasswd(String safePasswd) {
        this.safePasswd = safePasswd;
    }
}
