package com.mxnavi.tspv2.parklot.model;

import com.mxnavi.tspv2.model.LatLng;

import java.util.List;

/**
 * Created by Administrator on 2016/5/3.
 * 单个停车场详细信息类
 */
public class ParkingLotDetail {
    int id;
    String title;
    LatLng location;
    int typeId;
    int parkingSpaceNum;
    List<String> addresses;
    String phone;
    String info;
    int features;
    int cashType;
    int payType;
    int surface;
    // 限制条件，对应grestr
    int limitations;
    int maxHeight;
    List<Time>openingTime;
    ParkingLotRating rating;
    List<Price> priceschema;
    List<ParkingLotGeometry> geometry;
    RealTimeParkLotInfo realTimeParkLotDetail;

    /**
     * 获取停车场唯一ID(未取得结果时“-1”)
     * @return
     */
    public int getId() {
        return id;
    }

    /**
     * 设置停车场唯一ID(未取得结果时“-1”)
     * @param id
     */
    public void setId(int id) {
        this.id = id;
    }

    /**
     * 获取停车场名(未取得结果时“”)
     * @return
     */
    public String getTitle() {
        return title;
    }

    /**
     * 设置停车场名(未取得结果时“”)
     * @param title
     */
    public void setTitle(String title) {
        this.title = title;
    }

    /**
     * 获取经纬度
     * @return
     */
    public LatLng getLocation() {
        return location;
    }

    /**
     * 设置经纬度
     * @param location
     */
    public void setLocation(LatLng location) {
        this.location = location;
    }

    /**
     * 获取停车场类型id（2=on_street, 3=private, 4=carpark/off_street）(未取得结果时“-1”)
     * @return
     */
    public int getTypeId() {
        return typeId;
    }

    /**
     * 设置停车场类型id（2=on_street, 3=private, 4=carpark/off_street）(未取得结果时“-1”)
     * @param typeId
     */
    public void setTypeId(int typeId) {
        this.typeId = typeId;
    }

    /**
     * 获取总车位数(未取得结果时“-1”)
     * @return
     */
    public int getParkingSpaceNum() {
        return parkingSpaceNum;
    }

    /**
     * 获取总车位数(未取得结果时“-1”)
     * @param parkingSpaceNum
     */
    public void setParkingSpaceNum(int parkingSpaceNum) {
        this.parkingSpaceNum = parkingSpaceNum;
    }

    /**
     * 获取地址信息
     * @return
     */
    public List<String> getAddresses() {
        return addresses;
    }

    /**
     * 设置地址信息
     * @param addresses
     */
    public void setAddresses(List<String> addresses) {
        this.addresses = addresses;
    }

    /**
     * 获取电话(未取得结果时“”)
     * @return
     */
    public String getPhone() {
        return phone;
    }

    /**
     * 设置电话(未取得结果时“”)
     * @param phone
     */
    public void setPhone(String phone) {
        this.phone = phone;
    }

    /**
     * 获取停车场描述信息，内容可能比较长(未取得结果时“”)
     * @return
     */
    public String getInfo() {
        return info;
    }

    /**
     * 设置停车场描述信息，内容可能比较长(未取得结果时“”)
     * @param info
     */
    public void setInfo(String info) {
        this.info = info;
    }

    /**
     * 获取特征（参见附录B，features定义）(未取得结果时“-1”)
     * @return
     */
    public int getFeatures() {
        return features;
    }

    /**
     * 设置特征（参见附录B，features定义）(未取得结果时“-1”)
     * @param features
     */
    public void setFeatures(int features) {
        this.features = features;
    }

    /**
     * 获取Cash支付类型（参见附录B ctype定义）(未取得结果时“-1”)
     * @return
     */
    public int getCashType() {
        return cashType;
    }

    /**
     * 设置Cash支付类型（参见附录B ctype定义）(未取得结果时“-1”)
     * @param cashType
     */
    public void setCashType(int cashType) {
        this.cashType = cashType;
    }

    /**
     * 获取Payment机制（参见附录B ptype定义）(未取得结果时“-1”)
     * @return
     */
    public int getPayType() {
        return payType;
    }

    /**
     * 设置Payment机制（参见附录B ptype定义）(未取得结果时“-1”)
     * @param payType
     */
    public void setPayType(int payType) {
        this.payType = payType;
    }

    /**
     * 获取surface类型，有蓬没蓬等（参见附录B surface定义）(未取得结果时“-1”)
     * @return
     */
    public int getSurface() {
        return surface;
    }

    /**
     * 设置surface类型，有蓬没蓬等（参见附录B surface定义）(未取得结果时“-1”)
     * @param surface
     */
    public void setSurface(int surface) {
        this.surface = surface;
    }

    /**
     * 获取限制条件（参见附录B grestr定义）(未取得结果时“-1”)
     * @return
     */
    public int getLimitations() {
        return limitations;
    }

    /**
     *设置限制条件（参见附录B grestr定义）(未取得结果时“-1”)
     * @param limitations
     */
    public void setLimitations(int limitations) {
        this.limitations = limitations;
    }

    /**
     * 获取最大允许高度(单位:厘米),999为不限高(未取得结果时“-1”)
     * @return
     */
    public int getMaxHeight() {
        return maxHeight;
    }

    /**
     * 设置最大允许高度(单位:厘米),999为不限高(未取得结果时“-1”)
     * @param maxHeight
     */
    public void setMaxHeight(int maxHeight) {
        this.maxHeight = maxHeight;
    }

    /**
     * 获取营业时间
     * @return
     */
    public List<Time> getOpeningTime() {
        return openingTime;
    }

    /**
     * 设置营业时间
     * @param openingTime
     */
    public void setOpeningTime(List<Time> openingTime) {
        this.openingTime = openingTime;
    }

    /**
     * 获取评分
     * @return
     */
    public ParkingLotRating getRating() {
        return rating;
    }

    /**
     * 设置评分
     * @param rating
     */
    public void setRating(ParkingLotRating rating) {
        this.rating = rating;
    }

    /**
     * 获取收费标准
     * @return
     */
    public List<Price> getPriceschema() {
        return priceschema;
    }

    /**
     * 设置收费标准
     * @param priceschema
     */
    public void setPriceschema(List<Price> priceschema) {
        this.priceschema = priceschema;
    }

    /**
     *获取停车场形状信息
     * @return
     */
    public List<ParkingLotGeometry> getGeometry() {
        return geometry;
    }

    /**
     * 设置停车场形状信息
     * @param geometry
     */
    public void setGeometry(List<ParkingLotGeometry> geometry) {
        this.geometry = geometry;
    }

    /**
     * 获取实时停车场信息
     * @return
     */
    public RealTimeParkLotInfo getRealTimeParkLotDetail() {
        return realTimeParkLotDetail;
    }

    /**
     *设置实时停车场信息
     * @param realTimeParkLotDetail
     */
    public void setRealTimeParkLotDetail(RealTimeParkLotInfo realTimeParkLotDetail) {
        this.realTimeParkLotDetail = realTimeParkLotDetail;
    }
}
