package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by cikai on 2018/8/7.
 *
 * 空调位置信息
 */

public class AirPlaceInfo {

    long valid;
    long state;
    long stateException;

    /**
     * 获取是否有效(0-无效; 1-有效)
     * Bit: 1-吹脸
     *      2-吹脸/脚
     *      3-吹脚
     *      4-吹前挡风玻璃
     *      5-吹前挡风玻璃/脚
     *      6-吹前挡风玻璃/脸
     *      7-吹前挡风玻璃/脸/脚
     *      8-自动
     *      30-一键除霜
     *      31-前除霜
     *      32-后除霜
     * @return
     */
    public long getValid() {
        return valid;
    }

    /**
     * 设置是否有效(0-无效; 1-有效)
     * Bit: 1-吹脸
     *      2-吹脸/脚
     *      3-吹脚
     *      4-吹前挡风玻璃
     *      5-吹前挡风玻璃/脚
     *      6-吹前挡风玻璃/脸
     *      7-吹前挡风玻璃/脸/脚
     *      8-自动
     *      30-一键除霜
     *      31-前除霜
     *      32-后除霜
     * @param valid
     */
    public void setValid(long valid) {
        this.valid = valid;
    }

    /**
     * 位置标识(0-关; 1-开)
     * Bit: 同上
     * @return
     */
    public long getState() {
        return state;
    }

    /**
     * 位置标识(0-关; 1-开)
     * Bit: 同上
     * @param state
     */
    public void setState(long state) {
        this.state = state;
    }

    /**
     * 功能异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     * @return
     */
    public long getStateException() {
        return stateException;
    }

    /**
     * 功能异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     * @param stateException
     */
    public void setStateException(long stateException) {
        this.stateException = stateException;
    }
}
