package com.mxnavi.tspv2.remotecontrol.model;

import com.mxnavi.tspv2.core.PrioritizedRequestMessage;

/**
 * Created by zhaoll on 2018/8/8.
 * <p>
 * 配置项信息
 */
public class ConfigInfo {
    /**
     * 车载终端本地存储时间周期
     */
    Integer localCycle;
    /**
     * 正常时，信息上报时间周期
     */
    Integer reportCycle;
    /**
     * 警报时，信息上报时间周期
     */
    Integer alarmCycle;
    /**
     * 远程服务与管理平台域名
     */
    String enterprisePlatformUrl;
    /**
     * 远程服务与管理平台端口
     */
    Integer enterprisePlatformPort;
    /**
     * 公共平台域名
     */
    String publicPlatformUrl;
    /**
     * 公共平台端口
     */
    Integer publicPlatformPort;
    /**
     * 终端应答超时时间
     */
    Integer tboxTimeout;
    /**
     * 平台应答超时时间
     */
    Integer platformTimeout;
    /**
     * 连续三次登录失败后，到下一次等入的间隔时间
     */
    Integer interval;
    /**
     * 心跳周期
     */
    Integer heartbeatCycle;
    /**
     * 模式
     */
    ModeType modeType;
    /**
     * 模式上传时间 格式为：UNIX时间戳
     */
    long modeBeginTime;
    /**
     * 模式上传持续时间单位：分
     */
    Integer modeTimeQuantum;
    /**
     * 日志输出级别
     */
    LogLevel logLevel;


    /**
     * 获取 车载终端本地存储时间周期
     *
     * @return the local cycle
     */
    public Integer getLocalCycle() {
        return localCycle;
    }

    /**
     * 设置 车载终端本地存储时间周期
     *
     * @param localCycle the local cycle
     */
    public void setLocalCycle(Integer localCycle) {
        this.localCycle = localCycle;
    }

    /**
     * 获取 正常时，信息上报时间周期
     *
     * @return the report cycle
     */
    public Integer getReportCycle() {
        return reportCycle;
    }

    /**
     * 设置 正常时，信息上报时间周期
     *
     * @param reportCycle the report cycle
     */
    public void setReportCycle(Integer reportCycle) {
        this.reportCycle = reportCycle;
    }

    /**
     * 获取 警报时，信息上报时间周期
     *
     * @return the alarm cycle
     */
    public Integer getAlarmCycle() {
        return alarmCycle;
    }

    /**
     * 设置 警报时，信息上报时间周期
     *
     * @param alarmCycle the alarm cycle
     */
    public void setAlarmCycle(Integer alarmCycle) {
        this.alarmCycle = alarmCycle;
    }

    /**
     * 获取 远程服务与管理平台域名
     *
     * @return the enterprise platform url
     */
    public String getEnterprisePlatformUrl() {
        return enterprisePlatformUrl;
    }

    /**
     * 设置 远程服务与管理平台域名
     *
     * @param enterprisePlatformUrl the enterprise platform url
     */
    public void setEnterprisePlatformUrl(String enterprisePlatformUrl) {
        this.enterprisePlatformUrl = enterprisePlatformUrl;
    }

    /**
     * 获取远程服务与管理平台端口
     *
     * @return the enterprise platform port
     */
    public Integer getEnterprisePlatformPort() {
        return enterprisePlatformPort;
    }

    /**
     * 设置远程服务与管理平台端口
     *
     * @param enterprisePlatformPort the enterprise platform port
     */
    public void setEnterprisePlatformPort(Integer enterprisePlatformPort) {
        this.enterprisePlatformPort = enterprisePlatformPort;
    }

    /**
     * 获取公共平台域名
     *
     * @return the public platform url
     */
    public String getPublicPlatformUrl() {
        return publicPlatformUrl;
    }

    /**
     * 设置公共平台域名
     *
     * @param publicPlatformUrl the public platform url
     */
    public void setPublicPlatformUrl(String publicPlatformUrl) {
        this.publicPlatformUrl = publicPlatformUrl;
    }

    /**
     * 获取 公共平台端口
     *
     * @return the public platform port
     */
    public Integer getPublicPlatformPort() {
        return publicPlatformPort;
    }

    /**
     * 设置 公共平台端口
     *
     * @param publicPlatformPort the public platform port
     */
    public void setPublicPlatformPort(Integer publicPlatformPort) {
        this.publicPlatformPort = publicPlatformPort;
    }

    /**
     * 获取 终端应答超时时间
     *
     * @return the tbox timeout
     */
    public Integer getTboxTimeout() {
        return tboxTimeout;
    }

    /**
     * 设置 终端应答超时时间
     *
     * @param tboxTimeout the tbox timeout
     */
    public void setTboxTimeout(Integer tboxTimeout) {
        this.tboxTimeout = tboxTimeout;
    }

    /**
     * 获取 平台应答超时时间
     *
     * @return the platform timeout
     */
    public Integer getPlatformTimeout() {
        return platformTimeout;
    }

    /**
     * 设置 平台应答超时时间
     *
     * @param platformTimeout the platform timeout
     */
    public void setPlatformTimeout(Integer platformTimeout) {
        this.platformTimeout = platformTimeout;
    }

    /**
     * 获取 连续三次登录失败后，到下一次等入的间隔时间
     *
     * @return the interval
     */
    public Integer getInterval() {
        return interval;
    }

    /**
     * 设置 连续三次登录失败后，到下一次等入的间隔时间
     *
     * @param interval the interval
     */
    public void setInterval(Integer interval) {
        this.interval = interval;
    }

    /**
     * 获取 心跳周期
     *
     * @return the heartbeat cycle
     */
    public Integer getHeartbeatCycle() {
        return heartbeatCycle;
    }

    /**
     * 设置 心跳周期
     *
     * @param heartbeatCycle the heartbeat cycle
     */
    public void setHeartbeatCycle(Integer heartbeatCycle) {
        this.heartbeatCycle = heartbeatCycle;
    }

    /**
     * 获取 模式
     *
     * @return the mode type
     */
    public ModeType getModeType() {
        return modeType;
    }

    /**
     * 设置 模式
     *
     * @param modeType the mode type
     */
    public void setModeType(ModeType modeType) {
        this.modeType = modeType;
    }

    /**
     * 获取 模式上传时间 格式为：UNIX时间戳
     *
     * @return the mode begin time
     */
    public long getModeBeginTime() {
        return modeBeginTime;
    }

    /**
     * 设置 模式上传时间 格式为：UNIX时间戳
     *
     * @param modeBeginTime the mode begin time
     */
    public void setModeBeginTime(long modeBeginTime) {
        this.modeBeginTime = modeBeginTime;
    }

    /**
     * 获取 模式上传持续时间单位：分
     *
     * @return the mode time quantum
     */
    public Integer getModeTimeQuantum() {
        return modeTimeQuantum;
    }

    /**
     * 设置 模式上传持续时间单位：分
     *
     * @param modeTimeQuantum the mode time quantum
     */
    public void setModeTimeQuantum(Integer modeTimeQuantum) {
        this.modeTimeQuantum = modeTimeQuantum;
    }

    /**
     * 获取 日志输出级别
     * @return
     */
    public LogLevel getLogLevel() {
        return logLevel;
    }

    /**
     * 设置 日志输出级别
     * @param logLevel
     */
    public void setLogLevel(LogLevel logLevel) {
        this.logLevel = logLevel;
    }

    /**
     * The enum Mode type.
     */
    public static enum ModeType {
        /**
         * NORMAL mode type.
         */
        NORMAL(0X00),
        /**
         * Can file mode mode type.
         */
        CAN_FILE_MODE(0X01),
        /**
         * Tbox file mode mode type.
         */
        TBOX_FILE_MODE(0X02);

        private int value;

        ModeType (int value){
            this.value = value;
        }

        /**
         * 获取 value.
         *
         * @return the value
         */
        public int getValue() {
            return value;
        }
    }

    public static enum LogLevel {
        LOG_ERROR (0x00),
        LOG_WARNING (0x01),
        LOG_INFO (0x02),
        LOG_DEBUG (0x03);

        private int value;
        LogLevel(int value){
            this.value = value;
        }

        public int getValue() {
            return value;
        }
    }
}

