package com.mxnavi.tspv2.remotecontrol.model;


/**
 * Created by cikai on 2018/8/7.
 * 空调控制消息(请求/应答)
 * 备注：当查询时只填写common_param参数，tbox返回当前状态
 */
public class CtrlAirMessage {
    /**
     * 通用参数
     */
    CtrlCommonParamTbox commonParam;
    /**
     * 空调控制信息
     * Bit: 0-一键除霜
     *      1-最大制冷
     *      2-最大制热
     *      3-负离子
     *      4-座舱清洁
     *      5-全自动
     *      6-空气净化
     *      7-AC开关
     */
    CtrlCommonInfo airCtrlInfo;
    /**
     * 状态信息
     */
    AirStateInfo airStateInfo;

    /**
     * 获取 通用参数
     * @return
     */
    public CtrlCommonParamTbox getCommonParam() {
        return commonParam;
    }

    /**
     * 设置 通用参数
     * @param commonParam
     */
    public void setCommonParam(CtrlCommonParamTbox commonParam) {
        this.commonParam = commonParam;
    }

    /**
     * 获取空调控制信息
     * Bit: 0-一键除霜
     *      1-最大制冷
     *      2-最大制热
     *      3-负离子
     *      4-座舱清洁
     *      5-全自动
     *      6-空气净化
     *      7-AC开关
     * @return
     */
    public CtrlCommonInfo getAirCtrlInfo() {
        return airCtrlInfo;
    }

    /**
     * 设置 空调控制信息
     * Bit: 0-一键除霜
     *      1-最大制冷
     *      2-最大制热
     *      3-负离子
     *      4-座舱清洁
     *      5-全自动
     *      6-空气净化
     *      7-AC开关
     * @param airCtrlInfo
     */
    public void setAirCtrlInfo(CtrlCommonInfo airCtrlInfo) {
        this.airCtrlInfo = airCtrlInfo;
    }

    /**
     * 获取 状态信息
     * @return
     */
    public AirStateInfo getAirStateInfo() {
        return airStateInfo;
    }

    /**
     * 设置 状态信息
     * @param airStateInfo
     */
    public void setAirStateInfo(AirStateInfo airStateInfo) {
        this.airStateInfo = airStateInfo;
    }
}
