package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by zhaoll on 2018/8/22.
 * 驱动电机控制消息(请求/应答)
 *   app->服务器 请求时：
 *   如果只传"electromotor_message"中的"request_id"和"common_param"，表示"查询"指令，
 *   服务器应答消息中需包含"electromotor_message"和"resp_code"数据(失败时，只包含"electromotor_message"中"request_id"和"resp_code")
 *   如果除"resp_code"以外全部数据，表示"控制"指令，服务器应答消息中只包含"electromotor_message"中"request_id"和"resp_code"
 */

public class CtrlElectromotorMobileMsg {
    /**
     * 安防密码
     */
    String safePassword;
    /**
     * 通用参数
     */
    CtrlCommonParamMobile commonParam;
    /**
     * 应答状态码（100:成功;-100:失败;-101:参数缺失;-102:验证失败;-103:上一条指令未执行完成;-201:设置未成功;-202:vin重复;）
     */
    Integer respCode;
    /**
     * 驱动电机控制消息
     */
    CtrlElectromotorMsg electromotorMessage;
    /**
     * 获取 安防密码
     * @return
     */
    public String getSafePassword() {
        return safePassword;
    }

    /**
     * 设置 安防密码
     * @param safePassword
     */
    public void setSafePassword(String safePassword) {
        this.safePassword = safePassword;
    }

    /**
     * 获取 通用参数
     * @return
     */
    public CtrlCommonParamMobile getCommonParam() {
        return commonParam;
    }

    /**
     * 设置 通用参数
     * @param commonParam
     */
    public void setCommonParam(CtrlCommonParamMobile commonParam) {
        this.commonParam = commonParam;
    }

    /**
     * 获取 应答状态码（100:成功;-100:失败;-101:参数缺失;-102:验证失败;-103:上一条指令未执行完成;-201:设置未成功;-202:vin重复;）
     * @return
     */
    public Integer getRespCode() {
        return respCode;
    }

    /**
     * 设置 应答状态码（100:成功;-100:失败;-101:参数缺失;-102:验证失败;-103:上一条指令未执行完成;-201:设置未成功;-202:vin重复;）
     * @param respCode
     */
    public void setRespCode(Integer respCode) {
        this.respCode = respCode;
    }

    /**
     * 获取 驱动电机控制消息
     * @return
     */
    public CtrlElectromotorMsg getElectromotorMessage() {
        return electromotorMessage;
    }

    /**
     * 设置 驱动电机控制消息
     * @param electromotorMessage
     */
    public void setElectromotorMessage(CtrlElectromotorMsg electromotorMessage) {
        this.electromotorMessage = electromotorMessage;
    }
}
