package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by zhaoll on 2018/8/22.
 * 车门状态信息
 * Bit: 0-左前
 *      1-右前
 *      2-左后
 *      3-右后
 */

public class DoorsStateInfo {
    /**
     * 车锁状态: 0-关;1-开
     * Bit: 同上
     */
    long lockOnOff;
    /**
     * 车锁异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     */
    long lockStateException;
    /**
     * 车门开关状态: 0-关;1-开
     * Bit: 同上
     */
    long doorOnOff;
    /**
     * 车门开关异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     */
    long doorStateException;

    /**
     * 获取 车锁状态: 0-关;1-开
     * Bit: 同上
     * @return
     */
    public long getLockOnOff() {
        return lockOnOff;
    }

    /**
     * 设置 车锁状态: 0-关;1-开
     * Bit: 同上
     * @param lockOnOff
     */
    public void setLockOnOff(long lockOnOff) {
        this.lockOnOff = lockOnOff;
    }

    /**
     * 获取 车锁异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     * @return
     */
    public long getLockStateException() {
        return lockStateException;
    }

    /**
     * 设置 车锁异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     * @param lockStateException
     */
    public void setLockStateException(long lockStateException) {
        this.lockStateException = lockStateException;
    }

    /**
     * 获取 车门开关状态: 0-关;1-开
     * Bit: 同上
     * @return
     */
    public long getDoorOnOff() {
        return doorOnOff;
    }

    /**
     * 设置 车门开关状态: 0-关;1-开
     * Bit: 同上
     * @param doorOnOff
     */
    public void setDoorOnOff(long doorOnOff) {
        this.doorOnOff = doorOnOff;
    }

    /**
     * 获取 车门开关异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     * @return
     */
    public long getDoorStateException() {
        return doorStateException;
    }

    /**
     * 设置 车门开关异常状态(0-无异常; 1-有异常 例如：获取当前状态失败)
     * Bit: 同上
     * @param doorStateException
     */
    public void setDoorStateException(long doorStateException) {
        this.doorStateException = doorStateException;
    }
}
