package com.mxnavi.tspv2.remotecontrol.model;

import com.mxnavi.tspv2.remotecontrol.message.CtrlWindowsBean;

/**
 * Created by zhaoll on 2018/8/22.
 * 车窗控制信息
 */

public class WindowsCtrlInfo {
    /**
     * 位置标识
     */
    WindowPos windowPos;
    /**
     * 车窗开度值(有效值范围0x00-0x64 表示0-100%)
     * 0:为全关
     * 100:为全开
     * 0xFF:无效
     */
    Integer windowOpenedValue;
    /**
     * 车窗设定结果(0-成功; 1-失败)
     */
    Integer result;

    /**
     * 获取 位置标识
     * @return
     */
    public WindowPos getWindowPos() {
        return windowPos;
    }

    /**
     * 设置 位置标识
     * @param windowPos
     */
    public void setWindowPos(WindowPos windowPos) {
        this.windowPos = windowPos;
    }

    /**
     * 获取 车窗开度值(有效值范围0x00-0x64 表示0-100%)
     * 0:为全关
     * 100:为全开
     * 0xFF:无效
     * @return
     */
    public Integer getWindowOpenedValue() {
        return windowOpenedValue;
    }

    /**
     * 设置 车窗开度值(有效值范围0x00-0x64 表示0-100%)
     * 0:为全关
     * 100:为全开
     * 0xFF:无效
     * @param windowOpenedValue
     */
    public void setWindowOpenedValue(Integer windowOpenedValue) {
        this.windowOpenedValue = windowOpenedValue;
    }

    /**
     * 获取 车窗设定结果(0-成功; 1-失败)
     * @return
     */
    public Integer getResult() {
        return result;
    }

    /**
     * 设置 车窗设定结果(0-成功; 1-失败)
     * @param result
     */
    public void setResult(Integer result) {
        this.result = result;
    }

    public static enum WindowPos {
        /**
         * Left front window window type.
         */
        LEFT_FRONT_WINDOW(0x01),
        /**
         * Right front window window type.
         */
        RIGHT_FRONT_WINDOW(0x02),
        /**
         * Right back window window type.
         */
        RIGHT_BACK_WINDOW(0x03),
        /**
         * Left back window window type.
         */
        LEFT_BACK_WINDOW(0x04);

        private int value;

        WindowPos(int value){
            this.value = value;
        }
        /**
         * Gets value.
         *
         * @return the value
         */
        public int getValue() {
            return value;
        }
    }
}
