package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by cikai on 2018/8/7.
 */
public class WindowsInfo {
    /**
     * 类别标识
     */
    WindowType windowType;
    /**
     * 门窗开度值，0为全关，100为全开
     */
    Integer windowOpenedValue;
    /**
     * 查询状态时使用，远程控制不进行该字段的控制
     */
    WindowStatus windowStatus;

    /**
     * 获取类别标识
     *
     * @return the window type
     */
    public WindowType getWindowType() {
        return windowType;
    }

    /**
     * 设置类别标识
     *
     * @param windowType the window type
     */
    public void setWindowType(WindowType windowType) {
        this.windowType = windowType;
    }

    /**
     * 获取门窗开度值，0为全关，100为全开
     *
     * @return the window opened value
     */
    public Integer getWindowOpenedValue() {
        return windowOpenedValue;
    }

    /**
     * 设置门窗开度值，0为全关，100为全开
     *
     * @param windowOpenedValue the window opened value
     */
    public void setWindowOpenedValue(Integer windowOpenedValue) {
        this.windowOpenedValue = windowOpenedValue;
    }

    /**
     * 获取查询状态时使用，远程控制不进行该字段的控制
     *
     * @return the window status
     */
    public WindowStatus getWindowStatus() {
        return windowStatus;
    }

    /**
     * 设置查询状态时使用，远程控制不进行该字段的控制
     *
     * @param windowStatus the window status
     */
    public void setWindowStatus(WindowStatus windowStatus) {
        this.windowStatus = windowStatus;
    }

    /**
     * The enum Window type.
     */
    public static enum WindowType {
        /**
         * Left front window window type.
         */
        LEFT_FRONT_WINDOW(0X01),
        /**
         * Right front window window type.
         */
        RIGHT_FRONT_WINDOW(0X02),
        /**
         * Right back window window type.
         */
        RIGHT_BACK_WINDOW(0X03),
        /**
         * Left back window window type.
         */
        LEFT_BACK_WINDOW(0X04),
        /**
         * 功能异常状态
         */
        STATE_EXCEPTION_TYPE(0XFF);

        private int value;

        WindowType(int value) {
            this.value = value;
        }

        /**
         * Gets value.
         *
         * @return the value
         */
        public int getValue() {
            return value;
        }
    }

    /**
     * The enum Window status.
     */
    public static enum WindowStatus {
        /**
         * Window closed window status.
         */
        WINDOW_CLOSED(0X0),
        /**
         * Window opened window status.
         */
        WINDOW_OPENED(0X1),
        /**
         * Stopped window status.
         */
        STOPPED(0X2),
        /**
         * Auto up moving window status.
         */
        AUTO_UP_MOVING(0X3),
        /**
         * Manual up moving window status.
         */
        MANUAL_UP_MOVING(0X4),
        /**
         * Auto down moving window status.
         */
        AUTO_DOWN_MOVING(0X5),
        /**
         * Manual down moving window status.
         */
        MANUAL_DOWN_MOVING(0X6),
        /**
         * 功能异常状态
         */
        STATE1_EXCEPTION_STATUS(0XFF);

        private int value;

        WindowStatus(int value) {
            this.value = value;
        }

        /**
         * Gets value.
         *
         * @return the value
         */
        public int getValue() {
            return value;
        }
    }
}
