package com.mxnavi.tspv2.remotecontrol.model;

/**
 * Created by zhaoll on 2018/8/22.
 * 车窗状态信息
 */

public class WindowsStateInfo {
    /**
     * 位置标识
     */
    WindowsCtrlInfo.WindowPos windowPos;
    /**
     * 门窗开度值
     * 0为全关，100为全开
     * 0xFF:无效
     */
    Integer windowOpenedValue;
    /**
     * window status
     * 0x0: Window closed
     * 0x1: Window opened
     * 0x2: stopped
     * 0x3: Auto Up moving
     * 0x4: Manual Up moving
     * 0x5: Auto Down moving
     * 0x6: Manual Down moving
     * 0x7: Invalid
     * 0xFF: 无效
     */
    WindowStatus windowStatus;

    /**
     * 获取 位置标识
     * @return
     */
    public WindowsCtrlInfo.WindowPos getWindowPos() {
        return windowPos;
    }

    /**
     * 设置 位置标识
     * @param windowPos
     */
    public void setWindowPos(WindowsCtrlInfo.WindowPos windowPos) {
        this.windowPos = windowPos;
    }

    /**
     * 获取 门窗开度值
     * 0为全关，100为全开
     * 0xFF:无效
     * @return
     */
    public Integer getWindowOpenedValue() {
        return windowOpenedValue;
    }

    /**
     * 设置 门窗开度值
     * 0为全关，100为全开
     * 0xFF:无效
     * @param windowOpenedValue
     */
    public void setWindowOpenedValue(Integer windowOpenedValue) {
        this.windowOpenedValue = windowOpenedValue;
    }

    /**
     * 获取 window status
     * 0x0: Window closed
     * 0x1: Window opened
     * 0x2: stopped
     * 0x3: Auto Up moving
     * 0x4: Manual Up moving
     * 0x5: Auto Down moving
     * 0x6: Manual Down moving
     * 0x7: Invalid
     * 0xFF: 无效
     * @return
     */
    public WindowStatus getWindowStatus() {
        return windowStatus;
    }

    /**
     * 设置 window status
     * 0x0: Window closed
     * 0x1: Window opened
     * 0x2: stopped
     * 0x3: Auto Up moving
     * 0x4: Manual Up moving
     * 0x5: Auto Down moving
     * 0x6: Manual Down moving
     * 0x7: Invalid
     * 0xFF: 无效
     * @param windowStatus
     */
    public void setWindowStatus(WindowStatus windowStatus) {
        this.windowStatus = windowStatus;
    }

    public static enum WindowStatus {
        /**
         * Window closed
         */
        WINDOW_CLOSED (0x0),
        /**
         * Window opened
         */
        WINDOW_OPENED (0x1),
        /**
         * stopped
         */
        STOPPED (0x2),
        /**
         * Auto Up moving
         */
        AUTO_UP_MOVING (0x3),
        /**
         * Manual Up moving
         */
        MANUAL_UP_MOVING (0x4),
        /**
         * Auto Down moving
         */
        AUTO_DOWN_MOVING (0x5),
        /**
         * Manual Down moving
         */
        MANUAL_DOWN_MOVING (0x6),
        /**
         * 无效
         */
        STATE_EXCEPTION_STATUS(0xFF);

        private int value;

        WindowStatus(int value) {
            this.value = value;
        }
        /**
         * Gets value.
         *
         * @return the value
         */
        public int getValue() {
            return value;
        }
    }
}
