package com.mxnavi.tspv2.search.model;

import android.os.Parcel;
import android.os.Parcelable;
import android.os.Parcelable.Creator;

import com.mxnavi.tspv2.model.LatLng;

/**
 * Created by lenovo on 2016/6/12.
 */
public class GetLocationInfoQuery implements Parcelable {
    LatLng latLng;
    boolean calDistance;
    String adminCode;
 
    public GetLocationInfoQuery(){
    	
    }

    /**
     * 获取 经纬度
     * @return
     */
    public LatLng getLatLng() {
        return latLng;
    }

    /**
     * 设置 经纬度
     * @param latLng
     */
    public void setLatLng(LatLng latLng) {
        this.latLng = latLng;
    }
    /**
     * 是否需要计算该点到边界的最短距离，默认false
     * @return
     */
    public boolean isCalDistance() {
        return calDistance;
    }

    /**
     * 设置 是否需要计算该点到边界的最短距离，默认false
     * @param calDistance
     */
    public void setCalDistance(boolean calDistance) {
        this.calDistance = calDistance;
    }

    /**
     * 获取 行政区编码，adminCode和latLng不能同时为空
     * @return
     */
    public String getAdminCode() {
        return adminCode;
    }

    /**
     * 设置 行政区编码，adminCode和latLng不能同时为空
     * @param adminCode
     */
    public void setAdminCode(String adminCode) {
        this.adminCode = adminCode;
    }
    public static final Creator<GetLocationInfoQuery> CREATOR = new Creator<GetLocationInfoQuery>() {
        @Override
        public GetLocationInfoQuery createFromParcel(Parcel in) {
            return new GetLocationInfoQuery(in);
        }

        @Override
        public GetLocationInfoQuery[] newArray(int size) {
            return new GetLocationInfoQuery[size];
        }
    };
    protected GetLocationInfoQuery(Parcel in) {
    	latLng = in.readParcelable(LatLng.class.getClassLoader());
    	calDistance = in.readByte() != 0; 
        adminCode = in.readString();
    }
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeParcelable(latLng,flags);
        dest.writeByte((byte) (calDistance ? 1 : 0));  
        dest.writeString(adminCode);
       
    }
}
