package com.mxnavi.tspv2.user;


import com.mxnavi.tspv2.core.BaseTsp;
import com.mxnavi.tspv2.core.Config;
import com.mxnavi.tspv2.core.Constants;
import com.mxnavi.tspv2.core.MessageBuilder;
import com.mxnavi.tspv2.core.PrioritizedRequestMessage;
import com.mxnavi.tspv2.core.RequestDispathUtil;
import com.mxnavi.tspv2.core.common.CallBackListener;
import com.mxnavi.tspv2.core.message.MxNGTPMessage;
import com.mxnavi.tspv2.datashare.model.Message;
import com.mxnavi.tspv2.user.model.AddFeedbackQuery;
import com.mxnavi.tspv2.user.model.AvatarInfo;
import com.mxnavi.tspv2.user.model.BindMailInfo;
import com.mxnavi.tspv2.user.model.BindPhoneInfo;
import com.mxnavi.tspv2.user.model.Birthday;
import com.mxnavi.tspv2.user.model.FindPwdInfo;
import com.mxnavi.tspv2.user.model.LoginByCodeInfo;
import com.mxnavi.tspv2.user.model.LoginData;
import com.mxnavi.tspv2.user.model.LoginDataInfo;
import com.mxnavi.tspv2.user.model.LoginFrom3rdInfo;
import com.mxnavi.tspv2.user.model.LoginInfo;
import com.mxnavi.tspv2.user.model.ModityFeedbackQuery;
import com.mxnavi.tspv2.user.model.RefreshTokenResult;
import com.mxnavi.tspv2.user.model.RegisterByMailRequest;
import com.mxnavi.tspv2.user.model.RegisterByPhoneRequest;
import com.mxnavi.tspv2.user.model.SearchFeedbackInfo;
import com.mxnavi.tspv2.user.model.SearchFeedbackQuery;
import com.mxnavi.tspv2.user.model.SearchFeedbackResult;
import com.mxnavi.tspv2.user.model.SendPhoneValidNumInfo;
import com.mxnavi.tspv2.user.model.SendSmsInfo;
import com.mxnavi.tspv2.user.model.UpdatePwdInfo;
import com.mxnavi.tspv2.user.model.UserInfo;
import com.mxnavi.tspv2.user.model.UserInfoResult;
import com.mxnavi.tspv2.utils.Utils;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2016/4/5.
 * desc
 */
public class User extends BaseTsp {
//    private static String TOKEN = "";
//    private static int  USER_ID = 0;

    // 请求服务类型为用户管理
    final int thisServiceType = Config.MxNGTPServiceType.MX_USER_MANAGE.getServiceType();
    //  用户管理的ServiceData协议版本
    final int serviceDataVer = Config.MxNGTPServiceType.MX_USER_MANAGE.getServiceVer();

    // 请求服务类型为消息通知
    final int bindDeviceWithUserType = Config.MxNGTPServiceType.MX_MNS.getServiceType();
    // 消息通知的ServiceData协议版本
    final int mns_serviceDataVer = Config.MxNGTPServiceType.MX_MNS.getServiceVer();

    // 用户反馈服务及协议版本
    final int feedbackServiceType = Config.MxNGTPServiceType.MX_FEEDBACK.getServiceType();
    final int feedbackServiceDataVer = Config.MxNGTPServiceType.MX_FEEDBACK.getServiceVer();

    // 请求服务为用户鉴权及协议版本
    final int userServiceType = Config.MxNGTPServiceType.USER_AUTH.getServiceType();
    final int userServiceDataVer = Config.MxNGTPServiceType.USER_AUTH.getServiceVer();

    public User() {
    }

    private Map<Integer, Integer> listenertypeHashMap = new HashMap<Integer, Integer>();
    final int USERSENDPHONEVALIDNUM = 1;//获取手机验证码
    //    final int USERLOGINBYPHONE = 2;//通过手机登录
    final int USERLOGINBYACCOUNT = 3;//通过用户名密码登录
    final int USERAUTHORITYLOGINBYCODE = 4;//二维码登录(扫描设备)
    final int USERLOGINBYQRCODE = 5;//轮询登录(预登录设备)
    final int USERLOGINFROM3RD = 6;//OAuth2.0登录（拉起方式）
    final int USERREGISTERBYMAIL = 7;//通过邮箱注册
    final int USERBINDINGPHONE = 8;//绑定/更换手机号
    final int USERUPDATAPWD = 9;//修改密码
    final int USERFINDPASSWORDBYPHONE = 10;//通过手机号找回密码
    final int USERFINDPASSWORDBYMAIL = 11;//通过邮箱找回密码
    final int USERGETUSERINFO = 12;//获取个人信息
    final int USERUPDATAREGINFO = 13;//修改用户注册资料
    final int USERUPDATAAVATAR = 14;//修改头像
    final int USERLOGOUT = 15;//注销登录
    final int USE3RDLOGINQRURL = 16;//OAuth2.0登录（二维码方式）
    final int USEBINDMAIL = 17;//绑定/变更邮箱
    final int USERREFRESHTOKEN = 18;//刷新登录TOKEN
    final int BINDDEVICEWITHUSER = 19;//用户ID绑定设备号
    final int USER_REGISTERBYPHONE = 20;//手机号注册
    final int USER_VERIFYTOKEN = 21;//Token验证
    final int VERIFY_PHONE_VALID_NUM = 22;//手机验证码验证
    final int SEND_SMS = 23;//获取验证码，支持手机号验证
    final int LOGIN_BY_VALID_NUM = 24;//短信验证码登录
    final int SEND_SMS_BY_PRODUCT_ID = 25; //根据产品系列发送不同的短信验证信息
    final int FEEDBACK_SEARCH = 26; // 反馈列表查询
    final int FEEDBACK_ADD = 27; // 反馈列表添加
    final int FEEDBACK_MODIFY = 28; // 反馈列表修改
    final int FEEDBACK_DELETE = 29; // 反馈列表删除
    final int UPLOAD_PHOTO = 30; // 上传图片

    /**
     * Token验证
     *
     * @param userId              用户Id
     * @param token               用户登录标识
     * @param verifyTokenListener 回调监听
     * @return 请求ID，0:参数错误
     */
    public int verifyToken(String userId, String token, VerifyTokenListener verifyTokenListener) {
        return verifyToken(userId, token, verifyTokenListener, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * Token验证
     *
     * @param userId              用户Id
     * @param token               用户登录标识
     * @param verifyTokenListener 回调监听
     * @param timeOutSecs         接口超时时间，传0为不关注
     * @return 请求ID，0:参数错误
     */
    public int verifyToken(String userId, String token, VerifyTokenListener verifyTokenListener, int timeOutSecs) {
        return verifyToken(userId, token, verifyTokenListener, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * Token验证
     *
     * @param userId              用户Id
     * @param token               用户登录标识
     * @param verifyTokenListener 回调监听
     * @param timeOutSecs         接口超时时间，传0为不关注
     * @param priorityLevel       接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID，0:参数错误
     */
    public int verifyToken(String userId, String token, VerifyTokenListener verifyTokenListener, int timeOutSecs, int priorityLevel) {
        if (token == null) {
            if (verifyTokenListener != null) {
                verifyTokenListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        this.mVerifyTokenListener = verifyTokenListener;
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/verifyToken";
        JSONObject params = new JSONObject();
        try {
            params.put("token", token);
            params.put("userId", userId);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        String requestData = url + "?param=" + params.toString();
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USER_VERIFYTOKEN);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 手机号注册
     *
     * @param registerByPhoneRequest  手机号注册请求信息
     * @param registerByPhoneListener 回调接口
     * @return 请求ID，0:参数错误
     */
    public int registerByPhone(RegisterByPhoneRequest registerByPhoneRequest, RegisterByPhoneListener registerByPhoneListener) {
        return registerByPhone(registerByPhoneRequest, registerByPhoneListener, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 手机号注册
     *
     * @param registerByPhoneRequest  手机号注册请求信息
     * @param registerByPhoneListener 回调接口
     * @param timeOutSecs             接口超时时间，传0为不关注
     * @return 请求ID，0:参数错误
     */
    public int registerByPhone(RegisterByPhoneRequest registerByPhoneRequest, RegisterByPhoneListener registerByPhoneListener, int timeOutSecs) {
        return registerByPhone(registerByPhoneRequest, registerByPhoneListener, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 手机号注册
     *
     * @param registerByPhoneRequest  手机号注册请求信息
     * @param registerByPhoneListener 回调接口
     * @param timeOutSecs             接口超时时间，传0为不关注
     * @param priorityLevel           接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID，0:参数错误
     */
    public int registerByPhone(RegisterByPhoneRequest registerByPhoneRequest, RegisterByPhoneListener registerByPhoneListener, int timeOutSecs, int priorityLevel) {
        if (registerByPhoneRequest == null || registerByPhoneRequest.getPassword() == null || registerByPhoneRequest.getPhone() == null || registerByPhoneRequest.getValidNum() == null || registerByPhoneRequest.getValidSessionId() == null) {
            if (registerByPhoneListener != null) {
                registerByPhoneListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        this.mRegisterByPhoneListener = registerByPhoneListener;
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/registerByPhone";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("phone", registerByPhoneRequest.getPhone());
        params.put("valid_num", registerByPhoneRequest.getValidNum());
        params.put("valid_session_id", registerByPhoneRequest.getValidSessionId());
        params.put("password", Utils.md5(registerByPhoneRequest.getPassword()));
        params.put("nickname", registerByPhoneRequest.getNikeName());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USER_REGISTERBYPHONE);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 获取手机验证码
     *
     * @param phoneValidNumInfo
     * @return 请求ID，0:参数错误
     */
    public int sendPhoneValidNum(SendPhoneValidNumInfo phoneValidNumInfo) {
        return sendPhoneValidNum(phoneValidNumInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取手机验证码
     *
     * @param phoneValidNumInfo
     * @param timeOutSecs       接口超时时间，传0为不关注
     * @return 请求ID，0:参数错误
     */
    public int sendPhoneValidNum(SendPhoneValidNumInfo phoneValidNumInfo, int timeOutSecs) {
        return sendPhoneValidNum(phoneValidNumInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取手机验证码
     *
     * @param phoneValidNumInfo
     * @param timeOutSecs       接口超时时间，传0为不关注
     * @param priorityLevel     接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID，0:参数错误
     */
    public int sendPhoneValidNum(SendPhoneValidNumInfo phoneValidNumInfo, int timeOutSecs, int priorityLevel) {
        if (phoneValidNumInfo == null || phoneValidNumInfo.getCellPhoneNumber() == null) {
            if (sendPhoneValidNumSuccessListener != null) {
                sendPhoneValidNumSuccessListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/sendPhoneValidNum";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("phone", phoneValidNumInfo.getCellPhoneNumber());
        params.put("type", phoneValidNumInfo.getType());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERSENDPHONEVALIDNUM);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 获取手机验证码，支持手机号验证
     *
     * @param phoneValidNumInfo
     * @return 请求ID，0:参数错误
     */
    public int sendSms(SendPhoneValidNumInfo phoneValidNumInfo) {
        return sendSms(phoneValidNumInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取手机验证码，支持手机号验证
     *
     * @param phoneValidNumInfo
     * @param timeOutSecs       接口超时时间，传0为不关注
     * @return 请求ID，0:参数错误
     */
    public int sendSms(SendPhoneValidNumInfo phoneValidNumInfo, int timeOutSecs) {
        return sendSms(phoneValidNumInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取手机验证码，支持手机号验证
     *
     * @param phoneValidNumInfo
     * @param timeOutSecs       接口超时时间，传0为不关注
     * @param priorityLevel     接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID，0:参数错误
     */
    public int sendSms(SendPhoneValidNumInfo phoneValidNumInfo, int timeOutSecs, int priorityLevel) {
        if (phoneValidNumInfo == null || phoneValidNumInfo.getCellPhoneNumber() == null) {
            if (mSendSmsListener != null) {
                mSendSmsListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/sendSms";
        JSONObject obj = new JSONObject();
        try {
            obj.put("phone", phoneValidNumInfo.getCellPhoneNumber());
            obj.put("type", phoneValidNumInfo.getType());
        } catch (JSONException e) {
            e.printStackTrace();
        }
        String json = obj.toString();
        String requestData = url + "?" + json;
//        HashMap<String, Object> params = new HashMap<String, Object>();
//        params.put("phone", phoneValidNumInfo.getCellPhoneNumber());
//        params.put("type", phoneValidNumInfo.getType());
//        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessUTF8Msg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, SEND_SMS);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }
//    /**
//     * 通过手机登录
//     * @param loginByPhoneInfo
//     * @return 请求ID，0:参数错误
//     */
//    public int loginByPhone(LoginInfo loginByPhoneInfo) {
//        return loginByPhone(loginByPhoneInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
//    }
//
//    /**
//     * 通过手机登录
//     * @param loginByPhoneInfo
//     * @param timeOutSecs 接口超时时间，传0为不关注
//     * @return 请求ID，0:参数错误
//     */
//    public int loginByPhone(LoginInfo loginByPhoneInfo,int timeOutSecs) {
//        return loginByPhone(loginByPhoneInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
//    }
//
//    /**
//     * 通过手机登录
//     * @param loginByPhoneInfo
//     * @param timeOutSecs 接口超时时间，传0为不关注
//     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
//     * @return 请求ID，0:参数错误
//     */
//    public int loginByPhone(LoginInfo loginByPhoneInfo,int timeOutSecs,int priorityLevel){
//        if(loginByPhoneInfo == null||loginByPhoneInfo.getPhone()==null||loginByPhoneInfo.getValidNum()==null||loginByPhoneInfo.getValidSessionId()==null){
//            if (loginListener != null) {
//                loginListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT,Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
//            }
//            return 0;
//        }
//        int eventId = RequestDispathUtil.createEventId();
//        String url = "v2/user/loginByPhone";
//        HashMap<String, Object> params = new HashMap<String, Object>();
//        params.put("product_id", Config.CUSTOMER_KEY);
//        params.put("device_no",  Config.VIN);
//        params.put("device_type",  Config.DEVICE_TYPE);
//        params.put("phone",  loginByPhoneInfo.getPhone());
//        params.put("valid_num",  loginByPhoneInfo.getValidNum());
//        params.put("valid_session_id",  loginByPhoneInfo.getValidSessionId());
//        String requestData = Utils.makeUrl(url, params);
//        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
//        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
//        // 添加对应关系
//        addCallbackMap(eventId, USERLOGINBYPHONE);
//        RequestDispathUtil.submitRequest(requestMessage);
//        requestMessage.timeOutSeconds = timeOutSecs;
//        requestMessage.priority = priorityLevel;
//        return eventId;
//    }

    /**
     * 通过用户名密码登录
     *
     * @param loginInfo
     * @return 请求ID
     */
    public int loginByAccount(LoginInfo loginInfo) {
        return loginByAccount(loginInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过用户名密码登录
     *
     * @param loginInfo
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return
     */
    public int loginByAccount(LoginInfo loginInfo, int timeOutSecs) {
        return loginByAccount(loginInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过用户名密码登录
     *
     * @param loginInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int loginByAccount(LoginInfo loginInfo, int timeOutSecs, int priorityLevel) {
        if (loginInfo == null || loginInfo.getAccount() == null || loginInfo.getUserPwd() == null) {
            if (loginListener != null) {
                loginListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/userLogin";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("account", loginInfo.getAccount());
        params.put("user_pwd", Utils.md5(loginInfo.getUserPwd()));
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERLOGINBYACCOUNT);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 授权通过二维码登录
     *
     * @param loginByCodeInfo
     * @return 请求ID
     */
    public int authorityLoginByCode(LoginByCodeInfo loginByCodeInfo) {
        return authorityLoginByCode(loginByCodeInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 授权通过二维码登录
     *
     * @param loginByCodeInfo
     * @param timeOutSecs     接口超时时间，传0为不关注
     * @return
     */
    public int authorityLoginByCode(LoginByCodeInfo loginByCodeInfo, int timeOutSecs) {
        return authorityLoginByCode(loginByCodeInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 授权通过二维码登录
     *
     * @param loginByCodeInfo
     * @param timeOutSecs     接口超时时间，传0为不关注
     * @param priorityLevel   接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int authorityLoginByCode(LoginByCodeInfo loginByCodeInfo, int timeOutSecs, int priorityLevel) {
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/qrCodeScan";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", loginByCodeInfo.getProductId());
        params.put("device_no", loginByCodeInfo.getDeviceNo());
        params.put("device_type", loginByCodeInfo.getDeviceType());
        params.put("user_id", loginByCodeInfo.getUserId());
        params.put("token", Utils.converNullToEmpty(loginByCodeInfo.getToken()));
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERAUTHORITYLOGINBYCODE);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 通过二维码登录
     *
     * @return 请求ID
     */
    public int loginByQrCode() {
        return loginByQrCode(Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过二维码登录
     *
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return
     */
    public int loginByQrCode(int timeOutSecs) {
        return loginByQrCode(timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过二维码登录
     *
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int loginByQrCode(int timeOutSecs, int priorityLevel) {
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/qrCodeLogin";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERLOGINBYQRCODE);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 3.5.	OAuth2.0登录
     *
     * @param loginFrom3rdInfo
     * @return 请求ID
     */
    public int loginFrom3rd(LoginFrom3rdInfo loginFrom3rdInfo) {
        return loginFrom3rd(loginFrom3rdInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 3.5.	OAuth2.0登录
     *
     * @param loginFrom3rdInfo
     * @param timeOutSecs      接口超时时间，传0为不关注
     * @return
     */
    public int loginFrom3rd(LoginFrom3rdInfo loginFrom3rdInfo, int timeOutSecs) {
        return loginFrom3rd(loginFrom3rdInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 3.5.	OAuth2.0登录
     *
     * @param loginFrom3rdInfo
     * @param timeOutSecs      接口超时时间，传0为不关注
     * @param priorityLevel    接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int loginFrom3rd(LoginFrom3rdInfo loginFrom3rdInfo, int timeOutSecs, int priorityLevel) {
        if (loginFrom3rdInfo == null || loginFrom3rdInfo.getAppId() == null || loginFrom3rdInfo.getAuthorizationCode() == null) {
            if (loginListener != null) {
                loginListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/loginFrom3rd";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("device_no", Config.VIN);
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("platform", loginFrom3rdInfo.getPlatformType());
        params.put("code", loginFrom3rdInfo.getAuthorizationCode());
        params.put("app_id", loginFrom3rdInfo.getAppId());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERLOGINFROM3RD);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;

    }

    /**
     * 通过邮箱注册
     *
     * @param registerInfo
     * @return 请求ID
     */
    public int registerByMail(RegisterByMailRequest registerInfo) {
        return registerByMail(registerInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过邮箱注册
     *
     * @param registerInfo
     * @param timeOutSecs  接口超时时间，传0为不关注
     * @return
     */
    public int registerByMail(RegisterByMailRequest registerInfo, int timeOutSecs) {
        return registerByMail(registerInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过邮箱注册
     *
     * @param registerInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int registerByMail(RegisterByMailRequest registerInfo, int timeOutSecs, int priorityLevel) {
        if (registerInfo == null || registerInfo.getMail() == null || registerInfo.getUser_pwd() == null) {
            if (registerListener != null) {
                registerListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/registerByMail";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("mail", registerInfo.getMail());
        params.put("password", Utils.md5(registerInfo.getUser_pwd()));
//        params.put("name", Utils.converNullToEmpty(registerInfo.getUser_name()));
//        params.put("nickname",Utils.converNullToEmpty(userInfo.getNickname()));
//        if(userInfo.getBirthday() == null){
//            params.put("birthday",  "");
//        }else{
//            params.put("birthday", userInfo.getBirthday().toString());
//        }
//
//        params.put("sex",userInfo.gender);
//        params.put("location",  Utils.converNullToEmpty(userInfo.getLocation()));
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERREGISTERBYMAIL);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 绑定手机号
     *
     * @param UserManagerBindPhoneInfo
     * @return 请求ID
     */
    public int bindingPhone(BindPhoneInfo UserManagerBindPhoneInfo) {
        return bindingPhone(UserManagerBindPhoneInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 绑定手机号
     *
     * @param UserManagerBindPhoneInfo
     * @param timeOutSecs              接口超时时间，传0为不关注
     * @return
     */
    public int bindingPhone(BindPhoneInfo UserManagerBindPhoneInfo, int timeOutSecs) {
        return bindingPhone(UserManagerBindPhoneInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 绑定手机号
     *
     * @param bindPhoneInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int bindingPhone(BindPhoneInfo bindPhoneInfo, int timeOutSecs, int priorityLevel) {
        if (bindPhoneInfo == null || bindPhoneInfo.getPhone() == null || bindPhoneInfo.getValidnum() == null || bindPhoneInfo.getPassword() == null || bindPhoneInfo.getToken() == null || bindPhoneInfo.getValidnumSessionId() == null || bindPhoneInfo.getUserId() == null) {
            if (bindingPhoneListener != null) {
                bindingPhoneListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/bindingPhone";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("phone", bindPhoneInfo.getPhone());
        params.put("user_id", bindPhoneInfo.getUserId());
        params.put("token", bindPhoneInfo.getToken());
        params.put("valid_session_id", bindPhoneInfo.getValidnumSessionId());
        params.put("valid_num", bindPhoneInfo.getValidnum());
        params.put("user_pwd", Utils.md5(bindPhoneInfo.getPassword()));
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERBINDINGPHONE);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 修改密码
     *
     * @param updatePwdInfo
     * @return 请求ID
     */
    public int updatePwd(UpdatePwdInfo updatePwdInfo) {
        return updatePwd(updatePwdInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改密码
     *
     * @param updatePwdInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @return
     */
    public int updatePwd(UpdatePwdInfo updatePwdInfo, int timeOutSecs) {
        return updatePwd(updatePwdInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改密码
     *
     * @param updatePwdInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int updatePwd(UpdatePwdInfo updatePwdInfo, int timeOutSecs, int priorityLevel) {
        if (updatePwdInfo == null || updatePwdInfo.getNewPassword() == null || updatePwdInfo.getOldPassword() == null || updatePwdInfo.getToken() == null) {
            if (updatePwdListener != null) {
                updatePwdListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/updatePwd";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("old_pwd", Utils.md5(updatePwdInfo.getOldPassword()));
        params.put("new_pwd", Utils.md5(updatePwdInfo.getNewPassword()));
        params.put("user_id", updatePwdInfo.getUserId());
        params.put("token", updatePwdInfo.getToken());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERUPDATAPWD);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 通过手机号找回密码
     *
     * @param userManagerFindPwdInfo
     * @return 请求ID
     */
    public int findPasswordByPhone(FindPwdInfo userManagerFindPwdInfo) {
        return findPasswordByPhone(userManagerFindPwdInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过手机号找回密码
     *
     * @param userManagerFindPwdInfo
     * @param timeOutSecs            接口超时时间，传0为不关注
     * @return
     */
    public int findPasswordByPhone(FindPwdInfo userManagerFindPwdInfo, int timeOutSecs) {
        return findPasswordByPhone(userManagerFindPwdInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过手机号找回密码
     *
     * @param userManagerFindPwdInfo
     * @param timeOutSecs            接口超时时间，传0为不关注
     * @param priorityLevel          接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int findPasswordByPhone(FindPwdInfo userManagerFindPwdInfo, int timeOutSecs, int priorityLevel) {
        if (userManagerFindPwdInfo == null || userManagerFindPwdInfo.getPhone() == null || userManagerFindPwdInfo.getPassword() == null || userManagerFindPwdInfo.getValidnum() == null || userManagerFindPwdInfo.getValidnumSessionId() == null) {
            if (findPasswordByPhoneListener != null) {
                findPasswordByPhoneListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/getBackPasswordByPhone";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("phone", userManagerFindPwdInfo.getPhone());
        params.put("password", Utils.md5(userManagerFindPwdInfo.getPassword()));
        params.put("valid_num", userManagerFindPwdInfo.getValidnum());
        params.put("valid_session_id", userManagerFindPwdInfo.getValidnumSessionId());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERFINDPASSWORDBYPHONE);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 通过邮箱找回密码
     *
     * @param userManagerFindPwdInfo
     * @return 请求ID
     */
    public int findPasswordByMail(FindPwdInfo userManagerFindPwdInfo) {
        return findPasswordByMail(userManagerFindPwdInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过邮箱找回密码
     *
     * @param userManagerFindPwdInfo
     * @param timeOutSecs            接口超时时间，传0为不关注
     * @return
     */
    public int findPasswordByMail(FindPwdInfo userManagerFindPwdInfo, int timeOutSecs) {
        return findPasswordByMail(userManagerFindPwdInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 通过邮箱找回密码
     *
     * @param userManagerFindPwdInfo
     * @param timeOutSecs            接口超时时间，传0为不关注
     * @param priorityLevel          接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int findPasswordByMail(FindPwdInfo userManagerFindPwdInfo, int timeOutSecs, int priorityLevel) {
        if (userManagerFindPwdInfo == null || userManagerFindPwdInfo.getMail() == null) {
            if (findPasswordByMailListener != null) {
                findPasswordByMailListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/getBackPasswordByMail";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("mail", userManagerFindPwdInfo.getMail());
//        params.put("password", Utils.md5(userManagerFindPwdInfo.getPassword()));
//        params.put("valid_num", userManagerFindPwdInfo.getValidnum());
//        params.put("valid_session_id", userManagerFindPwdInfo.getValidnumSessionId());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERFINDPASSWORDBYMAIL);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 获取个人信息
     *
     * @return 请求ID
     */
    public int getUserInfo(String userId, String token) {
        return getUserInfo(userId, token, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取个人信息
     *
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return
     */
    public int getUserInfo(String userId, String token, int timeOutSecs) {
        return getUserInfo(userId, token, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 获取个人信息
     *
     * @return 请求ID
     */
    public int getUserInfo(String userId, String token, int timeOutSecs, int priorityLevel) {
        if (Utils.strIsEmpty(userId) || Utils.strIsEmpty(token)) {
            if (getUserInfoListener != null) {
                getUserInfoListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/getUserInfo";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("user_id", userId);
        params.put("token", token);
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERGETUSERINFO);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 修改用户注册资料
     *
     * @param UserInfo
     * @return 请求ID
     */
    public int updateRegInfo(UserInfo UserInfo) {
        return updateRegInfo(UserInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改用户注册资料
     *
     * @param UserInfo
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return
     */
    public int updateRegInfo(UserInfo UserInfo, int timeOutSecs) {
        return updateRegInfo(UserInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改用户注册资料
     *
     * @param userInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int updateRegInfo(UserInfo userInfo, int timeOutSecs, int priorityLevel) {
        if (userInfo == null || userInfo.getUserId() == null || userInfo.getToken() == null) {
            if (updateRegInfoListener != null) {
                updateRegInfoListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/updateRegInfo";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("name", Utils.converNullToEmpty(userInfo.getAcUserName()));
        params.put("nickname", Utils.converNullToEmpty(userInfo.getNickname()));
        if (userInfo.getBirthday() == null) {
            params.put("birthday", "");
        } else {
            params.put("birthday", userInfo.getBirthday().toString());
        }
        params.put("sex", userInfo.gender);
        params.put("location", Utils.converNullToEmpty(userInfo.getLocation()));
        params.put("user_id", userInfo.getUserId());
        params.put("token", userInfo.getToken());
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERUPDATAREGINFO);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 修改头像
     *
     * @param fileName 头像文件名
     * @param userId   用户ID
     * @param token    用户登录sessionId
     * @return 请求ID
     */
    public int updateAvatar(String fileName, String userId, String token) {
        return updateAvatar(fileName, userId, token, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改头像
     *
     * @param fileName    头像文件名
     * @param userId      用户ID
     * @param token       用户登录sessionId
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return 请求ID
     */
    public int updateAvatar(String fileName, String userId, String token, int timeOutSecs) {
        return updateAvatar(fileName, userId, token, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 修改头像
     *
     * @param fileName      头像文件名
     * @param userId        用户ID
     * @param token         用户登录sessionId
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID
     */
    public int updateAvatar(String fileName, String userId, String token, int timeOutSecs, int priorityLevel) {
        if (fileName == null || Utils.strIsEmpty(userId) || Utils.strIsEmpty(token)) {
            if (updateAvatarListener != null) {
                updateAvatarListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/updateAvatar";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("avatar", fileName);
        params.put("user_id", userId);
        params.put("token", token);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERUPDATAAVATAR);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 注销登录
     *
     * @param userId 用户ID
     * @param token  用户登录标识
     * @return
     */
    public int logout(String userId, String token) {
        return logout(userId, token, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 注销登录
     *
     * @param userId      用户ID
     * @param token       用户登录标识
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return
     */
    public int logout(String userId, String token, int timeOutSecs) {
        return logout(userId, token, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 注销登录
     *
     * @param userId        用户ID
     * @param token         用户登录标识
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int logout(String userId, String token, int timeOutSecs, int priorityLevel) {
        if (Utils.strIsEmpty(userId) || Utils.strIsEmpty(token)) {
            if (logoutListener != null) {
                logoutListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/logout";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("user_id", userId);
        params.put("token", token);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERLOGOUT);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * OAuth2.0登录（二维码方式)
     *
     * @param platformType 第三方平台 0:微信开放平台(weixin) 1:微博开放平台(weibo)  2:QQ互联(qq)
     * @param app_id       创建应用时得到的公钥
     * @return
     */
    public int get3rdLoginQrUrl(int platformType, String app_id) {
        return get3rdLoginQrUrl(platformType, app_id, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }


    /**
     * OAuth2.0登录（二维码方式)
     *
     * @param platformType 第三方平台 0:微信开放平台(weixin) 1:微博开放平台(weibo)  2:QQ互联(qq)
     * @param app_id       创建应用时得到的公钥
     * @param timeOutSecs  接口超时时间，传0为不关注
     * @return
     */
    public int get3rdLoginQrUrl(int platformType, String app_id, int timeOutSecs) {
        return get3rdLoginQrUrl(platformType, app_id, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * OAuth2.0登录（二维码方式)
     *
     * @param platformType  第三方平台 0:微信开放平台(weixin) 1:微博开放平台(weibo)  2:QQ互联(qq)
     * @param app_id        创建应用时得到的公钥
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int get3rdLoginQrUrl(int platformType, String app_id, int timeOutSecs, int priorityLevel) {
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/get3rdLoginQrUrl";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("platformType", platformType);
        params.put("app_id", Utils.converNullToEmpty(app_id));
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USE3RDLOGINQRURL);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 绑定/变更邮箱
     *
     * @param bindMailInfo
     * @return
     */
    public int BindMail(BindMailInfo bindMailInfo) {
        return BindMail(bindMailInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 绑定/变更邮箱
     *
     * @param bindMailInfo
     * @param timeOutSecs  接口超时时间，传0为不关注
     * @return
     */
    public int BindMail(BindMailInfo bindMailInfo, int timeOutSecs) {
        return BindMail(bindMailInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 激活邮箱
     *
     * @param bindMailInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int BindMail(BindMailInfo bindMailInfo, int timeOutSecs, int priorityLevel) {
        if (bindMailInfo == null || bindMailInfo.getUserId() == null || bindMailInfo.getToken() == null || bindMailInfo.getMail() == null || bindMailInfo.getUserId() == null || bindMailInfo.getToken() == null || bindMailInfo.getPassword() == null) {
            if (bindMailListener != null) {
                bindMailListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/bindMail";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("mail", bindMailInfo.getMail());
        params.put("user_id", bindMailInfo.getUserId());
        params.put("token", bindMailInfo.getToken());
        params.put("password", Utils.md5(bindMailInfo.getPassword()));
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USEBINDMAIL);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 刷新登录TOKEN
     *
     * @param userId
     * @param refreshToken
     * @return
     */
    public int refreshToken(String userId, String refreshToken) {
        return refreshToken(userId, refreshToken, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 刷新登录TOKEN
     *
     * @param userId
     * @param refreshToken
     * @param timeOutSecs  接口超时时间，传0为不关注
     * @return
     */
    public int refreshToken(String userId, String refreshToken, int timeOutSecs) {
        return refreshToken(userId, refreshToken, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 刷新登录TOKEN
     *
     * @param userId
     * @param refreshToken
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int refreshToken(String userId, String refreshToken, int timeOutSecs, int priorityLevel) {
        if (Utils.strIsEmpty(userId) || Utils.strIsEmpty(refreshToken)) {
            if (refreshTokenListener != null) {
                refreshTokenListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/refreshToken";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("user_id", userId);
        params.put("refreshToken", refreshToken);
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, USERREFRESHTOKEN);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 验证手机验证码
     *
     * @param phone          手机号
     * @param validNum       验证码
     * @param validSessionId 验证码服务器sessionid
     * @return 请求ID
     */
    public int verifyPhoneValidNum(String phone, String validNum, String validSessionId) {
        return verifyPhoneValidNum(phone, validNum, validSessionId, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 验证手机验证码
     *
     * @param phone          手机号
     * @param validNum       验证码
     * @param validSessionId 验证码服务器sessionid
     * @param timeOutSecs    超时时间
     * @return 请求ID
     */
    public int verifyPhoneValidNum(String phone, String validNum, String validSessionId, int timeOutSecs) {
        return verifyPhoneValidNum(phone, validNum, validSessionId, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 验证手机验证码
     *
     * @param phone          手机号
     * @param validNum       验证码
     * @param validSessionId 验证码服务器sessionid
     * @param timeOutSecs    超时时间
     * @param priorityLevel  优先级
     * @return 请求ID
     */
    public int verifyPhoneValidNum(String phone, String validNum, String validSessionId, int timeOutSecs, int priorityLevel) {
        if (phone == null || validNum == null || validSessionId == null) {
            if (mVerifyValidNumListener != null) {
                mVerifyValidNumListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/user/verifyPhoneValidNum";
        JSONObject obj = new JSONObject();
        try {
            obj.put("phone", phone);
            obj.put("valid_num", validNum);
            obj.put("valid_session_id", validSessionId);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        String json = obj.toString();
        String requestData = url + "?" + json;
//        HashMap<String, Object> params = new HashMap<String, Object>();
//        params.put("phone", phone);
//        params.put("valid_num", validNum);
//        params.put("valid_session_id", validSessionId);
//
//        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessUTF8Msg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, VERIFY_PHONE_VALID_NUM);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * \
     * 用户ID绑定设备号
     *
     * @param userId 用户ID
     * @param token  用户登录的token
     * @return
     */
    public int bindDeviceWithUser(String userId, String token) {
        return bindDeviceWithUser(userId, token, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 用户ID绑定设备号
     *
     * @param userId      用户ID
     * @param token       用户登录的token
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return
     */
    public int bindDeviceWithUser(String userId, String token, int timeOutSecs) {
        return bindDeviceWithUser(userId, token, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 用户ID绑定设备号
     *
     * @param userId        用户ID
     * @param token         用户登录的token
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int bindDeviceWithUser(String userId, String token, int timeOutSecs, int priorityLevel) {
        if (Utils.strIsEmpty(userId) || Utils.strIsEmpty(token)) {
            if (bindDeviceWithUserListener != null) {
                bindDeviceWithUserListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "cgi/gtpush/bindDeviceWithUser.do";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("device_no", Config.VIN);
        params.put("device_type", Config.DEVICE_TYPE);
        params.put("product_id", Config.CUSTOMER_KEY);
        params.put("user_id", userId);
        params.put("token", token);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, bindDeviceWithUserType, mns_serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, BINDDEVICEWITHUSER);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 短信验证码登录
     *
     * @param phone            设备号
     * @param verificationCode 设备类型
     * @param validSessionId   产品系列
     * @return
     */
    public int loginByValidNum(String phone, String verificationCode, String validSessionId) {
        return loginByValidNum(phone, verificationCode, validSessionId, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 短信验证码登录
     *
     * @param phone            设备号
     * @param verificationCode 设备类型
     * @param validSessionId   产品系列
     * @param timeOutSecs      接口超时时间，传0为不关注
     * @return
     */
    public int loginByValidNum(String phone, String verificationCode, String validSessionId, int timeOutSecs) {
        return loginByValidNum(phone, verificationCode, validSessionId, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 短信验证码登录
     *
     * @param phone            设备号
     * @param verificationCode 设备类型
     * @param validSessionId   产品系列
     * @param timeOutSecs      接口超时时间，传0为不关注
     * @param priorityLevel    接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return
     */
    public int loginByValidNum(String phone, String verificationCode, String validSessionId, int timeOutSecs, int priorityLevel) {
        if (phone == null || verificationCode == null || validSessionId == null) {
            if (mSendSmsListener != null) {
                mSendSmsListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "v2/login/sms";
        JSONObject obj = new JSONObject();
        try {
            obj.put("no", Config.VIN);
            obj.put("type", Config.DEVICE_TYPE);
            obj.put("productId", Config.CUSTOMER_KEY);
        } catch (JSONException e) {
            e.printStackTrace();
        }
//        String jsonValue = obj.toString();
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject.put("deviceInfo", obj);
            jsonObject.put("phone", phone);
            jsonObject.put("verificationCode", verificationCode);
            jsonObject.put("validSessionId", validSessionId);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        String requestData = url + "?" + jsonObject;
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessUTF8Msg(eventId, requestData, thisServiceType, serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, LOGIN_BY_VALID_NUM);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 根据不同的产品系列发送短信
     *
     * @param sendSmsInfo
     * @return 请求ID，0:参数错误
     */
    public int sendSmsByProductId(SendSmsInfo sendSmsInfo) {
        return this.sendSmsByProductId(sendSmsInfo, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 根据不同的产品系列发送短信
     *
     * @param sendSmsInfo
     * @param timeOutSecs 接口超时时间，传0为不关注
     * @return 请求ID，0:参数错误
     */
    public int sendSmsByProductId(SendSmsInfo sendSmsInfo, int timeOutSecs) {
        return this.sendSmsByProductId(sendSmsInfo, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 根据不同的产品系列发送短信
     *
     * @param sendSmsInfo
     * @param timeOutSecs   接口超时时间，传0为不关注
     * @param priorityLevel 接口优先级 0：低优先级，1：中优先级，2：高优先级
     * @return 请求ID，0:参数错误
     */
    public int sendSmsByProductId(SendSmsInfo sendSmsInfo, int timeOutSecs, int priorityLevel) {
        if (sendSmsInfo == null || sendSmsInfo.getDestNo() == null || sendSmsInfo.getSmsInfo() == null) {
            if (sendPhoneValidNumSuccessListener != null) {
                sendPhoneValidNumSuccessListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "cgi/sms/SendSms.do";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("dest_no", sendSmsInfo.getDestNo());
        params.put("sms_info", sendSmsInfo.getSmsInfo());
        params.put("type", sendSmsInfo.getType());
        params.put("product_id", sendSmsInfo.getProductId());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId, requestData, bindDeviceWithUserType, mns_serviceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, SEND_SMS_BY_PRODUCT_ID);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 反馈列表查询
     * @param searchFeedbackQuery
     * @return
     */
    public int searchFeedback(SearchFeedbackQuery searchFeedbackQuery){
        return searchFeedback(searchFeedbackQuery, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表查询
     * @param searchFeedbackQuery
     * @param timeOutSecs
     * @return
     */
    public int searchFeedback(SearchFeedbackQuery searchFeedbackQuery, int timeOutSecs){
        return searchFeedback(searchFeedbackQuery, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表查询
     * @param searchFeedbackQuery
     * @param timeOutSecs
     * @param priorityLevel
     * @return
     */
    public int searchFeedback(SearchFeedbackQuery searchFeedbackQuery, int timeOutSecs, int priorityLevel){
        if (searchFeedbackQuery == null || searchFeedbackQuery.getPage() == null
                || searchFeedbackQuery.getRows() == null ){
            if (mOnSearchFeedbackListener != null ){
                mOnSearchFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "feedback/search";
        HashMap<String, Object> params = new HashMap<String, Object>();
        if (!Utils.strIsEmpty(searchFeedbackQuery.getPkId())){
            params.put("pkId", searchFeedbackQuery.getPkId());
        }
        if (!Utils.strIsEmpty(searchFeedbackQuery.getUserId())){
            params.put("userId", searchFeedbackQuery.getUserId());
        }
        if (!Utils.strIsEmpty(searchFeedbackQuery.getUserName())){
           params.put("userName", searchFeedbackQuery.getUserName());
        }
        if (!Utils.strIsEmpty(searchFeedbackQuery.getAdminId())){
            params.put("adminId", searchFeedbackQuery.getAdminId());
        }
        if (!Utils.strIsEmpty(searchFeedbackQuery.getAnswerFlag())){
            params.put("answerFlag", searchFeedbackQuery.getAnswerFlag());
        }
        if (!Utils.strIsEmpty(searchFeedbackQuery.getDelFlag())){
            params.put("delFlag", searchFeedbackQuery.getDelFlag());
        }
        params.put("page", searchFeedbackQuery.getPage());
        params.put("rows", searchFeedbackQuery.getRows());
        if (!Utils.strIsEmpty(searchFeedbackQuery.getSort())){
            params.put("sort", searchFeedbackQuery.getSort());
        }
        if (!Utils.strIsEmpty(searchFeedbackQuery.getOrder())){
            params.put("order", searchFeedbackQuery.getOrder());
        }
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId,
                requestData, feedbackServiceType, feedbackServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, FEEDBACK_SEARCH);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 反馈列表添加
     * @param addFeedbackQuery 添加反馈列表请求参数
     * @return
     */
    public int addFeedback(AddFeedbackQuery addFeedbackQuery){
        return addFeedback(addFeedbackQuery, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表添加
     * @param addFeedbackQuery 添加反馈列表请求参数
     * @param timeOutSecs 超时时间
     * @return
     */
    public int addFeedback(AddFeedbackQuery addFeedbackQuery, int timeOutSecs){
        return addFeedback(addFeedbackQuery, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表添加
     * @param addFeedbackQuery 添加反馈列表请求参数
     * @param timeOutSecs 超时时间
     * @param priorityLevel 优先级
     * @return
     */
    public int addFeedback(AddFeedbackQuery addFeedbackQuery, int timeOutSecs, int priorityLevel){
        if (addFeedbackQuery == null || addFeedbackQuery.getUserId() == null
                || addFeedbackQuery.getUserName() == null || addFeedbackQuery.getQuestion() == null
                || addFeedbackQuery.getProductId() == null || addFeedbackQuery.getVin() == null ){
            if (mOnAddFeedbackListener != null){
                mOnAddFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "feedback/add";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("userId", addFeedbackQuery.getUserId());
        params.put("userName", addFeedbackQuery.getUserName());
        params.put("question", addFeedbackQuery.getQuestion());
        params.put("productId", addFeedbackQuery.getProductId());
        params.put("vin", addFeedbackQuery.getVin());
        if (!Utils.strIsEmpty("questionImg")){
            params.put("questionImg", addFeedbackQuery.getQuestionImg());
        }
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId,
                requestData, feedbackServiceType, feedbackServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, FEEDBACK_ADD);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 反馈列表修改
     * @param modityFeedbackQuery
     * @return
     */
    public int modityFeedback(ModityFeedbackQuery modityFeedbackQuery){
        return modityFeedback(modityFeedbackQuery, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表修改
     * @param modityFeedbackQuery
     * @param timeOutSecs
     * @return
     */
    public int modityFeedback(ModityFeedbackQuery modityFeedbackQuery, int timeOutSecs){
        return modityFeedback(modityFeedbackQuery, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表修改
     * @param modityFeedbackQuery
     * @param timeOutSecs
     * @param priorityLevel
     * @return
     */
    public int modityFeedback(ModityFeedbackQuery modityFeedbackQuery, int timeOutSecs, int priorityLevel){
        if (modityFeedbackQuery == null || modityFeedbackQuery.getPkId() == null || modityFeedbackQuery.getAdminId() == null
                || modityFeedbackQuery.getAnswer() == null || modityFeedbackQuery.getProductId() == null
                || modityFeedbackQuery.getVin() == null){
            if (mOnModifyFeedbackListener != null ){
                mOnModifyFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "feedback/modify";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("pkId", modityFeedbackQuery.getPkId());
        params.put("adminId", modityFeedbackQuery.getAdminId());
        params.put("answer", modityFeedbackQuery.getAnswer());
        params.put("productId", modityFeedbackQuery.getProductId());
        params.put("vin", modityFeedbackQuery.getVin());
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId,
                requestData, feedbackServiceType, feedbackServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, FEEDBACK_MODIFY);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 反馈列表删除
     * @param ids 主键，使用逗号分隔
     * @return
     */
    public int deleteFeedback(String ids){
        return deleteFeedback(ids, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表删除
     * @param ids 主键，使用逗号分隔
     * @param timeOutSecs
     * @return
     */
    public int deleteFeedback(String ids, int timeOutSecs){
        return deleteFeedback(ids, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 反馈列表删除
     * @param ids 主键，使用逗号分隔
     * @param timeOutSecs
     * @param priorityLevel
     * @return
     */
    public int deleteFeedback(String ids, int timeOutSecs, int priorityLevel){
        if (ids == null){
            if (mOnDeleteFeedbackListener != null ){
                mOnDeleteFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "feedback/delete";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("ids", ids);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId,
                requestData, feedbackServiceType, feedbackServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, FEEDBACK_DELETE);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    /**
     * 上传图片
     * @param file
     * @return
     */
    public int uploadPhoto(String file){
        return uploadPhoto(file, Config.DEFAULT_TIMEOUT_SECS, Config.DEFAULT_PRIORITY);
    }

    /**
     * 上传图片
     * @param file
     * @param timeOutSecs
     * @return
     */
    public int uploadPhoto(String file, int timeOutSecs){
        return uploadPhoto(file, timeOutSecs, Config.DEFAULT_PRIORITY);
    }

    /**
     * 上传图片
     * @param file
     * @param timeOutSecs
     * @param priorityLevel
     * @return
     */
    public int uploadPhoto(String file, int timeOutSecs, int priorityLevel){
        if (file == null ){
            if (mOnUploadPhotoListener != null ){
                mOnUploadPhotoListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
            }
            return 0;
        }
        int eventId = RequestDispathUtil.createEventId();
        String url = "auth/upload/uploadPhoto";
        HashMap<String, Object> params = new HashMap<String, Object>();
        params.put("file", file);
        String requestData = Utils.makeUrl(url, params);
        MxNGTPMessage.MxMessage businessMessage = MessageBuilder.instance().makeRequestBusinessMsg(eventId,
                requestData, userServiceType, userServiceDataVer);
        PrioritizedRequestMessage requestMessage = new PrioritizedRequestMessage(businessMessage);
        // 添加对应关系
        addCallbackMap(eventId, UPLOAD_PHOTO);
        RequestDispathUtil.submitRequest(requestMessage);
        requestMessage.timeOutSeconds = timeOutSecs;
        requestMessage.priority = priorityLevel;
        return eventId;
    }

    public interface SendPhoneValidNumSuccessListener extends CallBackListener {
        public void onSendPhoneValidNumSuccess(String validSessionId);
    }

    public interface LoginListener extends CallBackListener {
        public void onLoginSuccess(LoginData loginData);
    }

    public interface AuthorityLoginByCodeListener extends CallBackListener {
        public void onAuthorityLoginByCode();
    }

    public interface RegisterListener extends CallBackListener {
        public void onRegisterSuccess(String userId, String token);
    }

    public interface BindingPhoneListener extends CallBackListener {
        public void onBindingPhoneSuccess();
    }

    public interface UpdatePwdListener extends CallBackListener {
        public void onUpdatePwdSuccess();
    }

    public interface FindPasswordByPhoneListener extends CallBackListener {
        public void onFindPasswordByPhoneSuccess();
    }

    public interface FindPasswordByMailListener extends CallBackListener {
        public void onFindPasswordByMailSuccess();
    }

    public interface GetUserInfoListener extends CallBackListener {
        public void onGetUserInfo(UserInfoResult userInfoResult);
    }

    public interface UpdateRegInfoListener extends CallBackListener {
        public void onUpdateRegInfoSuccess();
    }

    public interface UpdateAvatarListener extends CallBackListener {
        public void onUpdateAvatarSuccess(AvatarInfo avatarInfo);
    }

    public interface LogoutListener extends CallBackListener {
        public void onLogoutSuccess();
    }

    public interface Get3rdLoginQrUrlListener extends CallBackListener {
        public void onGet3rdLoginQrUrl(String qrUrl);
    }

    public interface BindMailListener extends CallBackListener {
        public void onBindMail();
    }

    public interface RefreshTokenListener extends CallBackListener {
        public void onRefreshToken(RefreshTokenResult refreshTokenResult);
    }

    public interface BindDeviceWithUserListener extends CallBackListener {
        public void onBindDeviceWithUser();
    }

    public interface RegisterByPhoneListener extends CallBackListener {
        public void onRegisterByPhone();
    }

    public interface VerifyTokenListener extends CallBackListener {
        public void onVerifyToken();
    }

    public interface VerifyValidNumListener extends CallBackListener {
        /**
         * 验证码验证结果
         *
         * @param resultCode 100-成功，30003-验证码超时，30002-短信验证码校验错误
         */
        public void onVerifyValidNum(int resultCode);
    }

    public interface SendSmsListener extends CallBackListener {
        public void onSendSms(String validSessionId);
    }

    public interface SendSmsByProductListener extends CallBackListener {
        public void onSuccess();
    }

    public interface OnSearchFeedbackListener extends CallBackListener {
        public void onSearchFeedback(int requestId, SearchFeedbackResult searchFeedbackResult);
    }

    public interface OnAddFeedbackListener extends CallBackListener {
        public void onAddFeedback(int requestId);
    }

    public interface OnModifyFeedbackListener extends CallBackListener {
        public void onModifyFeedback(int requestId);
    }

    public interface OnDeleteFeedbackListener extends CallBackListener {
        public void onDeleteFeedback(int requestId);
    }

    public interface OnUploadPhotoListener extends CallBackListener {
        public void onUploadPhoto(int requestId, String url);
    }

    VerifyTokenListener mVerifyTokenListener;//Token验证
    SendPhoneValidNumSuccessListener sendPhoneValidNumSuccessListener;//获取手机验证码
    LoginListener loginListener;//登录
    AuthorityLoginByCodeListener authorityLoginByCodeListener;//二维码登录
    RegisterListener registerListener;//注册
    BindingPhoneListener bindingPhoneListener; //绑定/更换手机号
    UpdatePwdListener updatePwdListener; //修改密码
    FindPasswordByPhoneListener findPasswordByPhoneListener;//手机密码找回
    FindPasswordByMailListener findPasswordByMailListener;//邮箱密码找回
    GetUserInfoListener getUserInfoListener;//获取个人信息
    UpdateRegInfoListener updateRegInfoListener;//修改个人注册资料
    UpdateAvatarListener updateAvatarListener;//修改头像
    LogoutListener logoutListener;//注销登录
    Get3rdLoginQrUrlListener get3rdLoginQrUrlListener;//OAuth2.0登录（二维码方式）
    BindMailListener bindMailListener;//激活邮箱
    RefreshTokenListener refreshTokenListener;//刷新登录TOKEN
    BindDeviceWithUserListener bindDeviceWithUserListener;//用户ID绑定设备号
    RegisterByPhoneListener mRegisterByPhoneListener;//手机号注册
    VerifyValidNumListener mVerifyValidNumListener;//验证短信验证码
    SendSmsListener mSendSmsListener;//获取验证码，支持手机号验证
    SendSmsByProductListener mSendSmsByProductListener;//根据产品系列发送不同的短信验证信息
    OnSearchFeedbackListener mOnSearchFeedbackListener; // 用户反馈列表查询
    OnAddFeedbackListener mOnAddFeedbackListener; // 用户反馈列表添加
    OnModifyFeedbackListener mOnModifyFeedbackListener; // 用户反馈列表修改
    OnDeleteFeedbackListener mOnDeleteFeedbackListener; // 用户反馈列表删除
    OnUploadPhotoListener mOnUploadPhotoListener; // 上传图片

    public void setSendPhoneValidNumSuccessListener(SendPhoneValidNumSuccessListener sendPhoneValidNumSuccessListener) {
        this.sendPhoneValidNumSuccessListener = sendPhoneValidNumSuccessListener;
    }

    public void setLoginListener(LoginListener loginListener) {
        this.loginListener = loginListener;
    }

    public void setAuthorityLoginByCodeListener(AuthorityLoginByCodeListener authorityLoginByCodeListener) {
        this.authorityLoginByCodeListener = authorityLoginByCodeListener;
    }

    public void setRegisterListener(RegisterListener registerListener) {
        this.registerListener = registerListener;
    }

    public void setBindingPhoneListener(BindingPhoneListener bindingPhoneListener) {
        this.bindingPhoneListener = bindingPhoneListener;
    }

    public void setUpdatePwdListener(UpdatePwdListener updatePwdListener) {
        this.updatePwdListener = updatePwdListener;
    }

    public void setFindPasswordByPhoneListener(FindPasswordByPhoneListener findPasswordByPhoneListener) {
        this.findPasswordByPhoneListener = findPasswordByPhoneListener;
    }

    public void setFindPasswordByMailListener(FindPasswordByMailListener findPasswordByMailListener) {
        this.findPasswordByMailListener = findPasswordByMailListener;
    }

    public void setGetUserInfoListener(GetUserInfoListener getUserInfoListener) {
        this.getUserInfoListener = getUserInfoListener;
    }

    public void setUpdateRegInfoListener(UpdateRegInfoListener updateRegInfoListener) {
        this.updateRegInfoListener = updateRegInfoListener;
    }

    public void setUpdateAvatarListener(UpdateAvatarListener updateAvatarListener) {
        this.updateAvatarListener = updateAvatarListener;
    }

    public void setLogoutListener(LogoutListener logoutListener) {
        this.logoutListener = logoutListener;
    }

    public void setGet3rdLoginQrUrlListener(Get3rdLoginQrUrlListener get3rdLoginQrUrlListener) {
        this.get3rdLoginQrUrlListener = get3rdLoginQrUrlListener;
    }

    public void setBindMailListener(BindMailListener bindMailListener) {
        this.bindMailListener = bindMailListener;
    }

    public void setRefreshTokenListener(RefreshTokenListener refreshTokenListener) {
        this.refreshTokenListener = refreshTokenListener;
    }

    public void setBindDeviceWithUserListener(BindDeviceWithUserListener bindDeviceWithUserListener) {
        this.bindDeviceWithUserListener = bindDeviceWithUserListener;
    }

    public void setVerifyValidNumListener(VerifyValidNumListener verifyValidNumListener) {
        mVerifyValidNumListener = verifyValidNumListener;
    }

    public void setSendSmsListener(SendSmsListener sendSmsListener) {
        mSendSmsListener = sendSmsListener;
    }

    public void setSendSmsByProductListener(SendSmsByProductListener sendSmsByProductListener) {
        mSendSmsByProductListener = sendSmsByProductListener;
    }

    public void setOnSearchFeedbackListener(OnSearchFeedbackListener onSearchFeedbackListener){
        mOnSearchFeedbackListener = onSearchFeedbackListener;
    }

    public void setOnAddFeedbackListener(OnAddFeedbackListener onAddFeedbackListener){
        this.mOnAddFeedbackListener = onAddFeedbackListener;
    }

    public void setOnModifyFeedbackListener(OnModifyFeedbackListener onModifyFeedbackListener){
        this.mOnModifyFeedbackListener = onModifyFeedbackListener;
    }

    public void setOnDeleteFeedbackListener(OnDeleteFeedbackListener onDeleteFeedbackListener){
        this.mOnDeleteFeedbackListener = onDeleteFeedbackListener;
    }

    public void setOnUploadPhotoListener(OnUploadPhotoListener onUploadPhotoListener){
        this.mOnUploadPhotoListener = onUploadPhotoListener;
    }

    private void addCallbackMap(int eventId, int type) {
        super.addCallbackMap(eventId, User.this);
        synchronized (listenertypeHashMap) {
            listenertypeHashMap.put(eventId, type);
        }
    }

    @Override
    protected void removeCallbackMap(int eventId) {
        super.removeCallbackMap(eventId);
        synchronized (listenertypeHashMap) {
            listenertypeHashMap.remove(eventId);
        }
    }

    @Override
    protected void callTimeOut(int requestHandleId) {
        int type = listenertypeHashMap.get(requestHandleId);
        removeCallbackMap(requestHandleId);
        switch (type) {
            case USERSENDPHONEVALIDNUM://1
                if (sendPhoneValidNumSuccessListener != null) {
                    sendPhoneValidNumSuccessListener.onTimeOut();
                }
                break;
//            case USERLOGINBYPHONE://2
//                if (loginListener != null) {
//
//                    loginListener.onTimeOut();
//                }
//                break;
            case USERLOGINBYACCOUNT://3
                if (loginListener != null) {
                    loginListener.onTimeOut();
                }
                break;
            case USERAUTHORITYLOGINBYCODE://4
                if (authorityLoginByCodeListener != null) {
                    authorityLoginByCodeListener.onTimeOut();
                }
                break;
            case USERLOGINBYQRCODE://5
                if (loginListener != null) {
                    loginListener.onTimeOut();
                }
                break;
            case USERLOGINFROM3RD://6
                if (loginListener != null) {
                    loginListener.onTimeOut();
                }
                break;
            case USERREGISTERBYMAIL://7
                if (registerListener != null) {
                    registerListener.onTimeOut();
                }
                break;
            case USERBINDINGPHONE://8
                if (bindingPhoneListener != null) {
                    bindingPhoneListener.onTimeOut();
                }
                break;
            case USERUPDATAPWD://9
                if (updatePwdListener != null) {
                    updatePwdListener.onTimeOut();
                }
                break;
            case USERFINDPASSWORDBYPHONE://10
                if (findPasswordByPhoneListener != null) {
                    findPasswordByPhoneListener.onTimeOut();
                }
                break;
            case USERFINDPASSWORDBYMAIL://11
                if (findPasswordByMailListener != null) {
                    findPasswordByMailListener.onTimeOut();
                }
                break;
            case USERGETUSERINFO://12
                if (getUserInfoListener != null) {
                    getUserInfoListener.onTimeOut();
                }
                break;
            case USERUPDATAREGINFO://13
                if (updateRegInfoListener != null) {
                    updateRegInfoListener.onTimeOut();
                }
                break;
            case USERUPDATAAVATAR://14
                if (updateAvatarListener != null) {
                    updateAvatarListener.onTimeOut();
                }
                break;
            case USERLOGOUT://15
                if (logoutListener != null) {
                    logoutListener.onTimeOut();
                }
                break;
            case USE3RDLOGINQRURL://16
                if (get3rdLoginQrUrlListener != null) {
                    get3rdLoginQrUrlListener.onTimeOut();
                }
                break;
            case USEBINDMAIL://17
                if (bindMailListener != null) {
                    bindMailListener.onTimeOut();
                }
                break;
            case USERREFRESHTOKEN://18
                if (refreshTokenListener != null) {
                    refreshTokenListener.onTimeOut();
                }
                break;
            case BINDDEVICEWITHUSER://19
                if (bindDeviceWithUserListener != null) {
                    bindDeviceWithUserListener.onTimeOut();
                }
                break;
            case USER_REGISTERBYPHONE://20
                if (mRegisterByPhoneListener != null) {
                    mRegisterByPhoneListener.onTimeOut();
                }
                break;
            case USER_VERIFYTOKEN:
                if (mVerifyTokenListener != null) {
                    mVerifyTokenListener.onTimeOut();
                }
                break;
            case VERIFY_PHONE_VALID_NUM:
                if (mVerifyValidNumListener != null) {
                    mVerifyValidNumListener.onTimeOut();
                }
                break;
            case SEND_SMS://23
                if (mSendSmsListener != null) {
                    mSendSmsListener.onTimeOut();
                }
                break;
            case LOGIN_BY_VALID_NUM://24
                if (loginListener != null) {
                    loginListener.onTimeOut();
                }
                break;
            case SEND_SMS_BY_PRODUCT_ID: // 25
                if (mSendSmsByProductListener != null) {
                    mSendSmsByProductListener.onTimeOut();
                }
                break;
            case FEEDBACK_SEARCH:
                if (mOnSearchFeedbackListener != null ){
                    mOnSearchFeedbackListener.onTimeOut();
                }
                break;
            case FEEDBACK_ADD:
                if (mOnAddFeedbackListener != null ){
                    mOnAddFeedbackListener.onTimeOut();
                }
                break;
            case FEEDBACK_MODIFY:
                if (mOnModifyFeedbackListener != null ){
                    mOnModifyFeedbackListener.onTimeOut();
                }
                break;
            case FEEDBACK_DELETE:
                if (mOnDeleteFeedbackListener != null){
                    mOnDeleteFeedbackListener.onTimeOut();
                }
                break;
            case UPLOAD_PHOTO:
                if (mOnUploadPhotoListener != null){
                    mOnUploadPhotoListener.onTimeOut();
                }
                break;
            default:
                break;
        }
    }

    public LoginData loginInfo(JSONObject dataObject) {
        LoginData loginData = new LoginData();
        LoginDataInfo loginInfo = new LoginDataInfo();
        UserInfoResult user = new UserInfoResult();
        try {
            JSONObject loginInfoObj = dataObject.getJSONObject("loginInfo");
            loginInfo.setToken(loginInfoObj.getString("token"));
            loginInfo.setRefreshToken(loginInfoObj.getString("refreshToken"));
            loginInfo.setExpired(loginInfoObj.getInt("expired"));
            loginData.setLoginInfo(loginInfo);
            JSONObject userObj = dataObject.getJSONObject("user");

            if (userObj.has("id")) {
                String id = userObj.getString("id");
                user.setAcUserId(id);
            }
            if (userObj.has("name")) {
                String name = userObj.getString("name");
                user.setAcUserName(name);
            }
            if (userObj.has("nickname")) {
                String nickname = userObj.getString("nickname");
                user.setNickname(nickname);
            }
            if (userObj.has("avatar")) {
                String avatar = userObj.getString("avatar");
                user.setAvatar(avatar);
            }
            if (userObj.has("birthday")) {
                String strBirthday = userObj.getString("birthday");
                Birthday birthday = new Birthday();
                if (!Utils.strIsEmpty(strBirthday)) {
                    String[] strArry = strBirthday.split("-");
                    if (strArry.length == 3) {
                        birthday.setDay(Integer.parseInt(strArry[2]));
                        birthday.setMonth(Integer.parseInt(strArry[1]));
                        birthday.setYear(Integer.parseInt(strArry[0]));
                    } else if (strArry.length == 2) {
                        birthday.setMonth(Integer.parseInt(strArry[1]));
                        birthday.setYear(Integer.parseInt(strArry[0]));
                    } else if (strArry.length == 1) {
                        birthday.setYear(Integer.parseInt(strArry[0]));
                    }

                }
                user.setBirthday(birthday);
            }
            if (userObj.has("sex")) {
                int gender = userObj.getInt("sex");
                user.setGender(gender);
            }
            if (userObj.has("location")) {
                String location = userObj.getString("location");
                user.setLocation(location);
            }
            if (userObj.has("phone")) {
                String phone = userObj.getString("phone");
                user.setPhone(phone);
            }
            if (userObj.has("mail")) {
                String mail = userObj.getString("mail");
                user.setEmail(mail);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        loginData.setUser(user);
        return loginData;
    }

    protected void onCallBack(int requestHandleId, String response, boolean hasDSPTError, int errorCode, String errMsg) {
        Utils.loge("response=" + response);
        int type = listenertypeHashMap.get(requestHandleId);
        removeCallbackMap(requestHandleId);
        switch (type) {
            case USERSENDPHONEVALIDNUM://1
                if (sendPhoneValidNumSuccessListener != null) {
                    if (hasDSPTError) {
                        sendPhoneValidNumSuccessListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            String validSessionId = dataObject.getString("validSessionId");
                            sendPhoneValidNumSuccessListener.onSendPhoneValidNumSuccess(validSessionId);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            sendPhoneValidNumSuccessListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        sendPhoneValidNumSuccessListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
//            case USERLOGINBYPHONE://2
//                if (loginListener != null) {
//                    if(hasDSPTError){
//                        loginListener.onFail(errorCode,errMsg);
//                        return;
//                    }
//                    JSONTokener jsonParser = new JSONTokener(response);
//                    try {
//                        LoginData loginData ;
//                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
//                        int respCode = jsonObject.getInt("respCode");
//                        if (respCode == Constants.RESPCODE_SUCCESS) {
//                            JSONObject dataObject  = jsonObject.getJSONObject("data");
//                            loginData = loginInfo(dataObject);
//                            loginListener.onLoginSuccess(loginData);
//                        }else{
//                            String errorMsg = jsonObject.getString("msg");
//                            loginListener.onFail(respCode,errorMsg);
//                        }
//                    } catch (Exception e) {
//                        e.printStackTrace();
//                        loginListener.onFail(Constants
//                                        .ERROR_CODE_RESPONSEMSG_PARSEERROR
//                                , Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR
//                        );
//                    }
//                }
//                break;
            case LOGIN_BY_VALID_NUM:
            case USERLOGINBYACCOUNT://3
                if (loginListener != null) {
                    if (hasDSPTError) {
                        loginListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        LoginData loginData;
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            loginData = loginInfo(dataObject);
                            loginListener.onLoginSuccess(loginData);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            loginListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        loginListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERAUTHORITYLOGINBYCODE://4
                if (authorityLoginByCodeListener != null) {
                    if (hasDSPTError) {
                        authorityLoginByCodeListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                       /*         Object dataObject  = jsonObject.get("data");
                                if(dataObject instanceof JSONObject){
                                    Utils.loge("dataObject instanceof JSONObject");
                                }else{
                                    Utils.loge("------string");
                                }*/
                            authorityLoginByCodeListener.onAuthorityLoginByCode();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            authorityLoginByCodeListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        authorityLoginByCodeListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }

                break;
            case USERLOGINBYQRCODE://5
                if (loginListener != null) {
                    if (hasDSPTError) {
                        loginListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        LoginData loginData;
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            loginData = loginInfo(dataObject);
                            loginListener.onLoginSuccess(loginData);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            loginListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        loginListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERLOGINFROM3RD://6
                if (loginListener != null) {
                    if (hasDSPTError) {
                        loginListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser3rd = new JSONTokener(response);
                    try {
                        LoginData loginData;
                        JSONObject jsonObject = (JSONObject) jsonParser3rd.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            loginData = loginInfo(dataObject);
                            loginListener.onLoginSuccess(loginData);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            loginListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        loginListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERREGISTERBYMAIL://7
                if (registerListener != null) {
                    if (hasDSPTError) {
                        registerListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            String userId = dataObject.getString("userId");
                            String token = dataObject.getString("token");
                            registerListener.onRegisterSuccess(userId, token);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            registerListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        registerListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERBINDINGPHONE://8
                if (bindingPhoneListener != null) {
                    if (hasDSPTError) {
                        bindingPhoneListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            bindingPhoneListener.onBindingPhoneSuccess();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            bindingPhoneListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        bindingPhoneListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERUPDATAPWD://9
                if (updatePwdListener != null) {
                    if (hasDSPTError) {
                        updatePwdListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            updatePwdListener.onUpdatePwdSuccess();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            updatePwdListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        updatePwdListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERFINDPASSWORDBYPHONE://10
                if (findPasswordByPhoneListener != null) {
                    if (hasDSPTError) {
                        findPasswordByPhoneListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            findPasswordByPhoneListener.onFindPasswordByPhoneSuccess();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            findPasswordByPhoneListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        findPasswordByPhoneListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERFINDPASSWORDBYMAIL://11
                if (findPasswordByMailListener != null) {
                    if (hasDSPTError) {
                        findPasswordByMailListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            findPasswordByMailListener.onFindPasswordByMailSuccess();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            findPasswordByMailListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        findPasswordByMailListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERGETUSERINFO://12
                if (getUserInfoListener != null) {
                    if (hasDSPTError) {
                        getUserInfoListener.onFail(errorCode, errMsg);
                        return;
                    }
                    UserInfoResult info = new UserInfoResult();
                    JSONTokener GETUSERINFO = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) GETUSERINFO.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            if (dataObject.has("id")) {
                                String id = dataObject.getString("id");
                                info.setAcUserId(id);
                            }
                            if (dataObject.has("name")) {
                                String name = dataObject.getString("name");
                                info.setAcUserName(name);
                            }
                            if (dataObject.has("nickname")) {
                                String nickname = dataObject.getString("nickname");
                                info.setNickname(nickname);
                            }
                            if (dataObject.has("avatar")) {
                                String avatar = dataObject.getString("avatar");
                                info.setAvatar(avatar);
                            }
                            if (dataObject.has("birthday")) {
                                String strBirthday = dataObject.getString("birthday");
                                Birthday birthday = new Birthday();
                                if (!Utils.strIsEmpty(strBirthday)) {
                                    String[] strArry = strBirthday.split("-");
                                    if (strArry.length == 3) {
                                        birthday.setDay(Integer.parseInt(strArry[2]));
                                        birthday.setMonth(Integer.parseInt(strArry[1]));
                                        birthday.setYear(Integer.parseInt(strArry[0]));
                                    } else if (strArry.length == 2) {
                                        birthday.setMonth(Integer.parseInt(strArry[1]));
                                        birthday.setYear(Integer.parseInt(strArry[0]));
                                    } else if (strArry.length == 1) {
                                        birthday.setYear(Integer.parseInt(strArry[0]));
                                    }
                                }
                                info.setBirthday(birthday);
                            }
                            if (dataObject.has("sex")) {
                                int gender = dataObject.getInt("sex");
                                info.setGender(gender);
                            }
                            if (dataObject.has("location")) {
                                String location = dataObject.getString("location");
                                info.setLocation(location);
                            }
                            if (dataObject.has("phone")) {
                                String phone = dataObject.getString("phone");
                                info.setPhone(phone);
                            }
                            if (dataObject.has("mail")) {
                                String mail = dataObject.getString("mail");
                                info.setEmail(mail);
                            }
                            getUserInfoListener.onGetUserInfo(info);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            getUserInfoListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        getUserInfoListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERUPDATAREGINFO://13
                if (updateRegInfoListener != null) {
                    if (hasDSPTError) {
                        updateRegInfoListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParserUPDATAREGINFO = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParserUPDATAREGINFO.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            updateRegInfoListener.onUpdateRegInfoSuccess();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            updateRegInfoListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        updateRegInfoListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERUPDATAAVATAR://14
                if (updateAvatarListener != null) {
                    if (hasDSPTError) {
                        updateAvatarListener.onFail(errorCode, errMsg);
                        return;
                    }
                    AvatarInfo avatarInfo = new AvatarInfo();
                    JSONTokener jsonParserAAVATAR = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParserAAVATAR.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            String policy = dataObject.getString("policy");
                            String signature = dataObject.getString("signature");
                            avatarInfo.setPolicy(policy);
                            avatarInfo.setSignature(signature);
                            updateAvatarListener.onUpdateAvatarSuccess(avatarInfo);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            updateAvatarListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        updateAvatarListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERLOGOUT://15
                if (logoutListener != null) {
                    if (hasDSPTError) {
                        logoutListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            logoutListener.onLogoutSuccess();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            logoutListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        logoutListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USE3RDLOGINQRURL://16
                if (get3rdLoginQrUrlListener != null) {
                    if (hasDSPTError) {
                        get3rdLoginQrUrlListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            String qrUrl = dataObject.getString("qrUrl");
                            get3rdLoginQrUrlListener.onGet3rdLoginQrUrl(qrUrl);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            get3rdLoginQrUrlListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        get3rdLoginQrUrlListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USEBINDMAIL://17
                if (bindMailListener != null) {
                    if (hasDSPTError) {
                        bindMailListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            bindMailListener.onBindMail();
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            bindMailListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        bindMailListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USERREFRESHTOKEN://18
                if (refreshTokenListener != null) {
                    if (hasDSPTError) {
                        refreshTokenListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            RefreshTokenResult refreshTokenResult = new RefreshTokenResult();
                            refreshTokenResult.setToken(dataObject.getString("token"));
                            refreshTokenResult.setRefreshToken(dataObject.getString("refreshToken"));
                            refreshTokenResult.setExpired(dataObject.getInt("expired"));
                            refreshTokenListener.onRefreshToken(refreshTokenResult);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            refreshTokenListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        refreshTokenListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case BINDDEVICEWITHUSER:
                if (bindDeviceWithUserListener != null) {
                    if (hasDSPTError) {
                        bindDeviceWithUserListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            bindDeviceWithUserListener.onBindDeviceWithUser();
                        } else {
                            bindDeviceWithUserListener.onFail(respCode, "出错了");
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        bindDeviceWithUserListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USER_REGISTERBYPHONE:
                if (mRegisterByPhoneListener != null) {
                    if (hasDSPTError) {
                        mRegisterByPhoneListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            mRegisterByPhoneListener.onRegisterByPhone();
                        } else {
                            String msg = jsonObject.getString("msg");
                            mRegisterByPhoneListener.onFail(respCode, msg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mRegisterByPhoneListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case USER_VERIFYTOKEN:
                if (mVerifyTokenListener != null) {
                    if (hasDSPTError) {
                        mVerifyTokenListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            mVerifyTokenListener.onVerifyToken();
                        } else {
                            String msg = jsonObject.getString("msg");
                            mVerifyTokenListener.onFail(respCode, msg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mVerifyTokenListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case VERIFY_PHONE_VALID_NUM:
                if (mVerifyValidNumListener != null) {
                    if (hasDSPTError) {
                        mVerifyValidNumListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            mVerifyValidNumListener.onVerifyValidNum(respCode);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            mVerifyValidNumListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mVerifyValidNumListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case SEND_SMS:
                if (mSendSmsListener != null) {
                    if (hasDSPTError) {
                        mSendSmsListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS) {
                            JSONObject dataObject = jsonObject.getJSONObject("data");
                            String validSessionId = dataObject.getString("validSessionId");
                            mSendSmsListener.onSendSms(validSessionId);
                        } else {
                            String errorMsg = jsonObject.getString("msg");
                            mSendSmsListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mSendSmsListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case SEND_SMS_BY_PRODUCT_ID:
                if (mSendSmsByProductListener != null) {
                    if (hasDSPTError) {
                        mSendSmsByProductListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonParser = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonParser.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == 1) {
                            mSendSmsByProductListener.onSuccess();
                        } else {
                            String errorMsg = jsonObject.getString("errInfo");
                            mSendSmsByProductListener.onFail(respCode, errorMsg);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        mSendSmsByProductListener.onFail(Constants.ERROR_CODE_RESPONSEMSG_PARSEERROR, Constants.ERROR_MESSAGE_RESPONSEMSG_PARSEERROR);
                    }
                }
                break;
            case FEEDBACK_SEARCH:
                if (mOnSearchFeedbackListener != null){
                    if (hasDSPTError){
                        mOnSearchFeedbackListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonTokener = new JSONTokener(response);
                    SearchFeedbackResult searchFeedbackResult;
                    try {
                        JSONObject jsonObject = (JSONObject) jsonTokener.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS){
                            searchFeedbackResult = new SearchFeedbackResult();
                            searchFeedbackResult.setTotal(jsonObject.getInt("total"));
                            List<SearchFeedbackInfo> list = new ArrayList<SearchFeedbackInfo>();
                            if (jsonObject.has("data")){
                                JSONArray jsonArray = jsonObject.getJSONArray("data");
                                SearchFeedbackInfo searchFeedbackInfo;
                                for (int i =0; i<jsonArray.length(); i++ ) {
                                    searchFeedbackInfo = new SearchFeedbackInfo();
                                    JSONObject object = jsonArray.getJSONObject(i);
                                    searchFeedbackInfo.setPkId(object.getString("pkId"));
                                    searchFeedbackInfo.setUserId(object.getString("userId"));
                                    searchFeedbackInfo.setUserName(object.getString("userName"));
                                    if (object.has("adminId")) {
                                        searchFeedbackInfo.setAdminId(object.getString("adminId"));
                                    }
                                    searchFeedbackInfo.setQuestion(object.getString("question"));
                                    if (object.has("questionImg")){
                                        searchFeedbackInfo.setQuestionImg(object.getString("questionImg"));
                                    }
                                    if (object.has("answer")){
                                        searchFeedbackInfo.setAnswer(object.getString("answer"));
                                    }
                                    searchFeedbackInfo.setAnswerFlag(object.getString("answerFlag"));
                                    searchFeedbackInfo.setQuestionDateTime(object.getString("questionDateTime"));
                                    searchFeedbackInfo.setAnswerDateTime(object.getString("answerDateTime"));
                                    searchFeedbackInfo.setDelFlag(object.getString("delFlag"));
                                    searchFeedbackInfo.setProductId(object.getString("productId"));
                                    searchFeedbackInfo.setVin(object.getString("vin"));
                                    list.add(searchFeedbackInfo);
                                }
                            }
                            searchFeedbackResult.setList(list);
                            mOnSearchFeedbackListener.onSearchFeedback(requestHandleId, searchFeedbackResult);
                        }else {
                            mOnSearchFeedbackListener.onFail(respCode, errMsg);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                        mOnSearchFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
                    }
                }
                break;
            case FEEDBACK_ADD:
                if (mOnAddFeedbackListener != null){
                    if (hasDSPTError){
                        mOnAddFeedbackListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonTokener = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonTokener.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS){
                            mOnAddFeedbackListener.onAddFeedback(requestHandleId);
                        }else {
                            mOnAddFeedbackListener.onFail(respCode, errMsg);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                        mOnAddFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
                    }
                }
                break;
            case FEEDBACK_MODIFY:
                if (mOnModifyFeedbackListener != null ){
                    if (hasDSPTError){
                        mOnModifyFeedbackListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonTokener = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonTokener.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS){
                            mOnModifyFeedbackListener.onModifyFeedback(requestHandleId);
                        }else {
                            mOnModifyFeedbackListener.onFail(respCode, errMsg);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                        mOnModifyFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
                    }
                }
                break;
            case FEEDBACK_DELETE:
                if (mOnDeleteFeedbackListener != null ){
                    if (hasDSPTError){
                        mOnDeleteFeedbackListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonTokener = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonTokener.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS){
                            mOnDeleteFeedbackListener.onDeleteFeedback(requestHandleId);
                        }else {
                            mOnDeleteFeedbackListener.onFail(respCode, errMsg);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                        mOnDeleteFeedbackListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
                    }
                }
                break;
            case UPLOAD_PHOTO:
                if (mOnUploadPhotoListener != null){
                    if (hasDSPTError){
                        mOnUploadPhotoListener.onFail(errorCode, errMsg);
                        return;
                    }
                    JSONTokener jsonTokener = new JSONTokener(response);
                    try {
                        JSONObject jsonObject = (JSONObject) jsonTokener.nextValue();
                        int respCode = jsonObject.getInt("respCode");
                        if (respCode == Constants.RESPCODE_SUCCESS){
                            JSONObject object = jsonObject.getJSONObject("data");
                            String url = object.getString("url");
                            mOnUploadPhotoListener.onUploadPhoto(requestHandleId, url);
                        }else {
                            mOnUploadPhotoListener.onFail(respCode, errMsg);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                        mOnUploadPhotoListener.onFail(Constants.ERROR_CODE_INVALID_ARGUMENT, Constants.ERROR_MESSAGE_INVALID_ARGUMENT);
                    }
                }
                break;
            default:
                break;
        }
    }
}