package com.mxnavi.tspv2.weather.model;

import android.os.Parcel;
import android.os.Parcelable;

import com.mxnavi.tspv2.model.TspCity;
import com.mxnavi.tspv2.model.TspDate;

import java.io.Serializable;
import java.util.List;

/**
 * Created by Administrator on 2016/3/17.
 */
public class NormalWeatherResult implements Parcelable ,Serializable {
    /**
     * PM2.5			异常值:-1
     */
    int pm25;
    int	 aqi;/*天气质量指数*/
    String ariLevel;
    int	 districtNum;
    TspDate currentDate;
    int currentWeek;
    TspCity distInfo;
    private static final long serialVersionUID = 1L;
    /**
     * 当前天气
     */
    CurrentWeather currentWeather;
    /**
     * 天气指数
     */
    List<WeatherIndex> weatherIndexList;
    /**
     * 未来三天天气
     */
    List<FutureWeather> futureWeatherList;

    public NormalWeatherResult() {
    }

    public NormalWeatherResult(int pm25, int aqi, int districtNum, TspDate currentDate, int currentWeek, TspCity distInfo, CurrentWeather currentWeather, List<WeatherIndex> weatherIndexList, List<FutureWeather> futureWeatherList) {
        this.pm25 = pm25;
        this.aqi = aqi;
        this.districtNum = districtNum;
        this.currentDate = currentDate;
        this.currentWeek = currentWeek;
        this.distInfo = distInfo;
        this.currentWeather = currentWeather;
        this.weatherIndexList = weatherIndexList;
        this.futureWeatherList = futureWeatherList;
    }

    protected NormalWeatherResult(Parcel in) {
        pm25 = in.readInt();
        aqi = in.readInt();
        districtNum = in.readInt();
        currentDate = in.readParcelable(TspDate.class.getClassLoader());
        currentWeek = in.readInt();
        distInfo = in.readParcelable(TspCity.class.getClassLoader());
        currentWeather = in.readParcelable(CurrentWeather.class.getClassLoader());
        weatherIndexList = in.createTypedArrayList(WeatherIndex.CREATOR);
        futureWeatherList = in.createTypedArrayList(FutureWeather.CREATOR);
    }

    public static final Creator<NormalWeatherResult> CREATOR = new Creator<NormalWeatherResult>() {
        @Override
        public NormalWeatherResult createFromParcel(Parcel in) {
            return new NormalWeatherResult(in);
        }

        @Override
        public NormalWeatherResult[] newArray(int size) {
            return new NormalWeatherResult[size];
        }
    };

    /**
     * 获取PM2.5(-1为未知)
     * @return PM2.5(-1为未知)
     */
    public int getPm25() {
        return pm25;
    }

    /**
     * 设置PM2.5(-1为未知)
     * @param pm25
     */
    public void setPm25(int pm25) {
        this.pm25 = pm25;
    }

    /**
     * 获取天气质量指数(-1为未知)
     * @return 天气质量指数(-1为未知)
     */
    public int getAqi() {
        return aqi;
    }

    /**
     * 设置天气质量指数(-1为未知)
     * @param aqi
     */
    public void setAqi(int aqi) {
        this.aqi = aqi;
    }

    public String getAriLevel() {
		return ariLevel;
	}

	public void setAriLevel(String ariLevel) {
		this.ariLevel = ariLevel;
	}

	/**
     * 获取日期
     * @return 日期
     */
    public TspDate getCurrentDate() {
        return currentDate;
    }

    /**
     * 设置日期
     * @param currentDate
     */
    public void setCurrentDate(TspDate currentDate) {
        this.currentDate = currentDate;
    }

    /**
     * 获取实况节点
     * @return 实况节点
     */
    public CurrentWeather getCurrentWeather() {
        return currentWeather;
    }

    /**
     * 设置实况节点
     * @param currentWeather
     */
    public void setCurrentWeather(CurrentWeather currentWeather) {
        this.currentWeather = currentWeather;
    }

    /**
     * 获取指数数组节点
     * @return 指数数组节点
     */
    public List<WeatherIndex> getWeatherIndexList() {
        return weatherIndexList;
    }

    /**
     * 设置指数数组节点
     * @param weatherIndexList
     */
    public void setWeatherIndexList(List<WeatherIndex> weatherIndexList) {
        this.weatherIndexList = weatherIndexList;
    }

    /**
     * 获取未来几天天气节点
     * @return 未来几天天气节点
     */
    public List<FutureWeather> getFutureWeatherList() {
        return futureWeatherList;
    }

    /**
     * 设置未来几天天气节点
     * @param futureWeatherList
     */
    public void setFutureWeatherList(List<FutureWeather> futureWeatherList) {
        this.futureWeatherList = futureWeatherList;
    }


    /**
     * 获取该天气所属地区
     * @return 该天气所属地区
     */
    public TspCity getDistInfo() {
        return distInfo;
    }

    /**
     * 设置该天气所属地区
     * @param distInfo
     */
    public void setDistInfo(TspCity distInfo) {
        this.distInfo = distInfo;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(pm25);
        dest.writeInt(aqi);
        dest.writeInt(districtNum);
        dest.writeParcelable(currentDate, flags);
        dest.writeInt(currentWeek);
        dest.writeParcelable(distInfo, flags);
        dest.writeParcelable(currentWeather, flags);
        dest.writeTypedList(weatherIndexList);
        dest.writeTypedList(futureWeatherList);
    }
}
