package com.mxnavi.tspv2.weather.model;

import android.os.Parcel;
import android.os.Parcelable;

import java.io.Serializable;

/**
 * Created by wangq on 2016/3/17.
 * 天气指数类
 */

public class WeatherIndex implements Parcelable,Serializable {
    private static final long serialVersionUID = 1L;
    /* ID */
    private int idxId ;

    /* name */
    private String	indexName = null;

    /* level */
    private String	indexLevel = null;

    /* information */
    private String	indexInfo = null;

    public WeatherIndex() {
    }

    public WeatherIndex(int idxId, String indexName, String indexLevel, String indexInfo) {
        this.idxId = idxId;
        this.indexName = indexName;
        this.indexLevel = indexLevel;
        this.indexInfo = indexInfo;
    }

    protected WeatherIndex(Parcel in) {
        idxId = in.readInt();
        indexName = in.readString();
        indexLevel = in.readString();
        indexInfo = in.readString();
    }

    public static final Creator<WeatherIndex> CREATOR = new Creator<WeatherIndex>() {
        @Override
        public WeatherIndex createFromParcel(Parcel in) {
            return new WeatherIndex(in);
        }

        @Override
        public WeatherIndex[] newArray(int size) {
            return new WeatherIndex[size];
        }
    };

    /**
     * 获取指数ID
     * @return 指数ID
     */
    public int getIdxId() {
        return idxId;
    }

    /**
     * 设置指数ID
     * @param idxId
     */
    public void setIdxId(int idxId) {
        this.idxId = idxId;
    }

    /**
     * 获取指数名称
     * @return 指数名称
     */
    public String getIndexName() {
        return indexName;
    }

    /**
     * 设置指数名称
     * @param indexName
     */
    public void setIndexName(String indexName) {
        this.indexName = indexName;
    }

    /**
     * 获取指数级别
     * @return 指数级别
     */
    public String getIndexLevel() {
        return indexLevel;
    }

    /**
     * 设置指数级别
     * @param indexLevel
     */
    public void setIndexLevel(String indexLevel) {
        this.indexLevel = indexLevel;
    }

    /**
     * 获取指数详情
     * @return 指数详情
     */
    public String getIndexInfo() {
        return indexInfo;
    }

    /**
     * 设置指数详情
     * @param indexInfo
     */
    public void setIndexInfo(String indexInfo) {
        this.indexInfo = indexInfo;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeInt(idxId);
        dest.writeString(indexName);
        dest.writeString(indexLevel);
        dest.writeString(indexInfo);
    }
}
